using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    public partial class Form1 : Form
    {
        public Form2 form_prediccion_jornada; // formulario de prediccion de multiples equipos una jornada
        public Form3 form_test_prediccion;// formulario de test de los metodos de prediccin
        public Form4 form_prediccion_partido;// formulario de prediccion de un partido
        public Form5 form_estadisticas_equipos; // formulario de estadisticas de quipos
        public Form6 form_estadisticas_signos; // formulario de estadisticas de signos
        public Form7 form_trayectorias_equipos;// formulario de trayectoria de los equipos
        public Form8 form_acerca_de;// formulario con la informacion general del programa

        string nombre_BBDD;
      
        public Form1()
        {
            InitializeComponent();
        }

        private void prediccinJornadaToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            bool bool_aux1;

            // el nombre de la BBDD lo formamos aadiendo a la Common Program Files folder el nombre del fichero
            nombre_BBDD = Application.StartupPath + "\\lfsuite.mdb";// fichero de la BBDD
            bool_aux1 = File.Exists(nombre_BBDD); // miramos si existe el fichero de la BBDD

            if (bool_aux1==false){

                // se ha producido algun error al recuperar la cabecera de alguno de los dos ficheros
                MessageBox.Show("ERROR: Se ha producido un error al iniciar la aplicacion");

            }else{

                // se conecta con la BBDD
                if (!Analizador.Conectar(nombre_BBDD))
                {
                    MessageBox.Show("ERROR: No se ha podido acceder a los datos");
                }
                else
                {
                    // si se ha podido conectar a la BBDD se muestra el formulario "Acerca de"

                    // antes de abrir el formulario miramos si ya existe 
                    if (form_acerca_de == null)
                    {
                        form_acerca_de = new Form8();
                        form_acerca_de.MdiParent = this;
                        form_acerca_de.StartPosition = FormStartPosition.CenterScreen;
                        form_acerca_de.MostrarLogotipo();
                        form_acerca_de.Show();

                        // poner aqui el aviso de que la oeperacion ha ido bien
                    }
                    else
                    {
                        MessageBox.Show("ERROR: La ventana ya est abierta");
                    }//if

                }//if

            }//if

        }

        private void prediccinJornadaToolStripMenuItem_Click_1(object sender, EventArgs e)
        {

            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_prediccion_jornada == null)
                {
                    form_prediccion_jornada = new Form2();
                    form_prediccion_jornada.MdiParent = this;
                    form_prediccion_jornada.StartPosition = FormStartPosition.CenterScreen;
                    form_prediccion_jornada.Show();   
                    
                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");   
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }

        private void estadsticasEquiposToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_estadisticas_equipos == null)
                {
                    form_estadisticas_equipos = new Form5();
                    form_estadisticas_equipos.MdiParent = this;
                    form_estadisticas_equipos.StartPosition = FormStartPosition.CenterScreen;
                    form_estadisticas_equipos.Show();

                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }//estadsticasEquiposToolStripMenuItem_Click

        private void estadsticasSignosToolStripMenuItem_Click(object sender, EventArgs e)
        {

            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_estadisticas_signos == null)
                {
                    form_estadisticas_signos = new Form6();
                    form_estadisticas_signos.MdiParent = this;
                    form_estadisticas_signos.StartPosition = FormStartPosition.CenterScreen;
                    form_estadisticas_signos.Show();

                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }

        private void trayectoriasEquiposToolStripMenuItem_Click(object sender, EventArgs e)
        {

            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_trayectorias_equipos == null)
                {
                    form_trayectorias_equipos = new Form7();
                    form_trayectorias_equipos.MdiParent = this;
                    form_trayectorias_equipos.StartPosition = FormStartPosition.CenterScreen;
                    form_trayectorias_equipos.Show();

                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }

        private void salirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // al cerrar se llamara al evento FormClosed que desconectara la aplicacon de la BBDD y luego cerrara la ventana
            this.Close();

        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            DialogResult resultado = MessageBox.Show(" Desea salir de la aplicacin ?", "Salir", MessageBoxButtons.OKCancel);
            
            if (resultado == DialogResult.OK ){
                
                // se ha de cerrar la aplicacion
                e.Cancel= false;
                
                // antes de salir habra que desconectarse de la BBDD pero antes debermos saber si estamos conectados
                if (Analizador.EstaConectado())
                {
                    if (Analizador.Desconectar())
                    {

                        // se llama al Garbage Colector para que cierre y elimine todo lo que esta pendiente de cerrar y esperamos a que termine
                        GC.Collect();
                        GC.WaitForPendingFinalizers();
                        
                    }
                    else
                    {
                        MessageBox.Show("ERROR: No se ha podido desconectar de la BBDD");
                    }//if

                }//if

            }else{
                
                // NO se ha de cerrar la aplicacion
                e.Cancel = true;

            }
        }

        private void testMtodosPrediccinToolStripMenuItem_Click(object sender, EventArgs e)
        {

            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_test_prediccion == null)
                {
                    form_test_prediccion = new Form3();
                    form_test_prediccion.MdiParent = this;
                    form_test_prediccion.StartPosition = FormStartPosition.CenterScreen;
                    form_test_prediccion.Show();

                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }

        private void prediccinPartidoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // antes de abrir el formulario miramos si estamos conectados a la BBDD
            if (Analizador.EstaConectado())
            {

                // antes de abrir el formulario miramos si ya existe 
                if (form_prediccion_partido == null)
                {
                    form_prediccion_partido = new Form4();
                    form_prediccion_partido.MdiParent = this;
                    form_prediccion_partido.StartPosition = FormStartPosition.CenterScreen;
                    form_prediccion_partido.Show();

                    // poner aqui el aviso de que la oeperacion ha ido bien
                }
                else
                {
                    MessageBox.Show("ERROR: La ventana ya est abierta");
                }//if

            }
            else
            {

                MessageBox.Show("ERROR: No hay datos disponibles");

            }//if

        }

        private void sobreLFSuiteToolStripMenuItem_Click(object sender, EventArgs e)
        {

             // antes de abrir el formulario miramos si ya existe 
            if (form_acerca_de == null)
             {
                 form_acerca_de = new Form8();
                 form_acerca_de.MdiParent = this;
                 form_acerca_de.StartPosition = FormStartPosition.CenterScreen;
                 form_acerca_de.MostrarLogotipo();
                 form_acerca_de.Show();

                 // poner aqui el aviso de que la oeperacion ha ido bien
             }
             else
             {
                 MessageBox.Show("ERROR: La ventana ya est abierta");
             }//if

        }

        private void ayudaToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void analisisToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string target = "http://www.tolaemon.com/lfsuite/ayuda.htm";
           
            try
            {
                System.Diagnostics.Process.Start(target);
            }
            catch
                (
                 System.ComponentModel.Win32Exception noBrowser)
            {
                if (noBrowser.ErrorCode == -2147467259)
                    MessageBox.Show(noBrowser.Message);
            }
            catch (System.Exception other)
            {
                MessageBox.Show(other.Message);
            }


        }

        private void audaToolStripMenuItem_Click(object sender, EventArgs e)
        {
             string target = "http://www.tolaemon.com/lfsuite/";

             try
             {
                 System.Diagnostics.Process.Start(target);
             }
             catch
                 (
                  System.ComponentModel.Win32Exception noBrowser)
             {
                 if (noBrowser.ErrorCode == -2147467259)
                     MessageBox.Show(noBrowser.Message);
             }
             catch (System.Exception other)
             {
                 MessageBox.Show(other.Message);
             }

        }

    }
}