using System;  
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    public partial class Form2 : Form
    {
        // se utilizan para guardar la informacin de todas las temporadas que se insertara en la ComboBox y sus identificadores
        List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();
        List<int> Lista_Temporadas_Id = new List<int>();
        
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            List<string> ListaEquiposEquipo = new List<string>();
            List<int> ListaEquiposId = new List<int>();
            int aux_int;
            int aux_int2;

            // al cargar el formulario llenamos las 2 combos primeras con los equipos contenidos en la BBDD
            aux_int = Analizador.ConsultaEquipos(ListaEquiposId, ListaEquiposEquipo);

            ListaEquiposEquipo.Sort(); // OJO al ordenar: se nos desparejara la correspondencia entre los arryas de Ids y de Nombres Equipos!!
            for (aux_int2 = 0; aux_int2 < aux_int; aux_int2++){

                comboBox1.Items.Add(ListaEquiposEquipo[aux_int2]);
                comboBox2.Items.Add(ListaEquiposEquipo[aux_int2]);           
            
            }//for

            // se llenan las ComboBoxes correspondientes con la informacin de las temporadas
            aux_int2 = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (aux_int = 0; aux_int < aux_int2; aux_int++)
            {
                comboBox3.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
                comboBox4.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
            }//for

            // inicializamos las ComboBoxes de temporada con la primera y ulima temporada
            comboBox3.Text = Lista_Temporadas_Anio1_Anio2[aux_int2 - 1].ToString();
            comboBox4.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();

            // inicializamos la View List con los equipos entrados por el usuario
            listView1.Clear();
            listView1.View = View.Details;// para que se vean los detalles nombre de columna etc

            listView1.Columns.Add("N", 30, HorizontalAlignment.Center);
            listView1.Columns.Add("Local", 100, HorizontalAlignment.Center);
            listView1.Columns.Add("Visitante", 100, HorizontalAlignment.Center);            
            listView1.Columns.Add("Victorias", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("1", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("X", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("2", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Victorias", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Empates", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("P Analizados", 85, HorizontalAlignment.Center);

        }

        private void listBox3_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            int aux_int;
            string aux_string = "";
            string equipo_uno = "";
            string equipo_dos = "";
            int victorias_uno = 0;
            int goles_uno = 0;
            float unos = 0;
            float equis = 0;
            float doses = 0;
            int goles_dos = 0;
            int victorias_dos = 0;
            int empates = 0;
            int total_partidos = 0;
            ListViewItem lvitem_aux;

            // se imprime el texto indicando el tipo de analisis
            if (radioButton2.Checked){
                textBox1.Text = textBox1.Text + "Iniciado Analisis de Probabilidad Con Factor Campo\r\n";
            }else if (radioButton3.Checked){
                textBox1.Text = textBox1.Text + "Iniciado Analisis de Probabilidad Sin Factor Campo\r\n";
            }//if

            // comienza el procesado de cada enfrentamiento
            for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
            {
                //1 se obtiene la probabilidad de 1 x 2 utilizando el metodo seleccionado por el usuario
                lvitem_aux = listView1.Items[aux_int];

                equipo_uno = Convert.ToString(lvitem_aux.SubItems[1].Text);
                equipo_dos = Convert.ToString(lvitem_aux.SubItems[2].Text);

                textBox1.Text = textBox1.Text + "Analizando enfrentamiento " + (aux_int + 1).ToString() + ": " + equipo_uno + " " + equipo_dos + "\r\n";
                                
                // se llama a una u otra funcion dependiendo del tipo de analisis seleccionado por el ususario
                if (radioButton2.Checked){
                    Analizador.ProbabilidadConFactorCampo(equipo_uno, equipo_dos,Lista_Temporadas_Id[comboBox3.SelectedIndex],Lista_Temporadas_Id[comboBox4.SelectedIndex], ref victorias_uno, ref goles_uno, ref unos, ref equis, ref doses, ref goles_dos, ref victorias_dos, ref empates, ref total_partidos);                
                }else if (radioButton3.Checked){
                    Analizador.ProbabilidadSinFactorCampo(equipo_uno, equipo_dos,Lista_Temporadas_Id[comboBox3.SelectedIndex],Lista_Temporadas_Id[comboBox4.SelectedIndex], ref victorias_uno, ref goles_uno, ref unos, ref equis, ref doses, ref goles_dos, ref victorias_dos, ref empates, ref total_partidos);                  
                }//if

                //3 se aaden los componentes del resultado en un ListViewItem que luego se inseratara en la View List
                listView1.Items[aux_int].SubItems[3].Text = victorias_uno.ToString();
                //4 goles uno
                listView1.Items[aux_int].SubItems[4].Text = goles_uno.ToString();
                //5 unos
                aux_string = String.Format("{0:0.00}", unos);
                listView1.Items[aux_int].SubItems[5].Text = aux_string;
                //6 equis
                aux_string = String.Format("{0:0.00}",equis);
                listView1.Items[aux_int].SubItems[6].Text = aux_string;
                //7 doses
                aux_string = String.Format("{0:0.00}", doses);
                listView1.Items[aux_int].SubItems[7].Text = aux_string;
                //8 goles 
                listView1.Items[aux_int].SubItems[8].Text = goles_dos.ToString();
                //9 victorias dos
                listView1.Items[aux_int].SubItems[9].Text = victorias_dos.ToString();
                //10 empates
                listView1.Items[aux_int].SubItems[10].Text = empates.ToString();
                //11 total partidos analizados
                listView1.Items[aux_int].SubItems[11].Text = total_partidos.ToString();

            }//for
            textBox1.Text = textBox1.Text + "Finalizado Analisis\r\n";
        
        }


        private void button3_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            ListViewItem lvitem_aux;

            // antes de insertar miramos que ningun campo esta vacio y que los dos equipos seleccionados no son el mismo
            if ((comboBox1.SelectedIndex >= 0) && (comboBox2.SelectedIndex >= 0) && (comboBox1.SelectedIndex != comboBox2.SelectedIndex))
            {

                lvitem_aux = new ListViewItem((listView1.Items.Count+1).ToString());
                //N
                lvitem_aux.SubItems.Add((comboBox1.Items[comboBox1.SelectedIndex]).ToString());
                //Local
                lvitem_aux.SubItems.Add((comboBox2.Items[comboBox2.SelectedIndex]).ToString());
                //Visitante
                lvitem_aux.SubItems.Add("");
                //Victorias uno
                lvitem_aux.SubItems.Add("");
                //Goles uno
                lvitem_aux.SubItems.Add("");                
                //1 unos
                lvitem_aux.SubItems.Add("");
                //X equis
                lvitem_aux.SubItems.Add("");
                //2 doses
                lvitem_aux.SubItems.Add("");
                //Goles dos
                lvitem_aux.SubItems.Add("");  
                //Victorias dos
                lvitem_aux.SubItems.Add("");
                //Empates
                lvitem_aux.SubItems.Add("");
                //Total partidos
                lvitem_aux.SubItems.Add("");
                
                //Se inserta en la lista
                listView1.Items.Add(lvitem_aux);
            }else{
                MessageBox.Show("ERROR: Debe seleccionar 2 equipos diferentes");
            }
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {

            LFSuite.Form1 FormPadre = (LFSuite.Form1) this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_prediccion_jornada = null;

        }

        private void button4_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            // al hacer el close ya se llamara al evento closing del formulario
            this.Close();
        }


        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            int aux_int;
            ListViewItem lvitem_aux;
            
            // si pulsan el Button "Borrar" y hay algun elemento de la ListView seleccionado lo eliminamos
            if (e.KeyCode == Keys.Delete)
            {

                if (listView1.SelectedItems.Count > 0)
                {
                    // se borra el elemento
                    listView1.Items.RemoveAt(listView1.SelectedIndices[0]);

                    // actualizamos el valor de los indices ( el numero que aparecene en la 1a columna )
                    for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
                    {
                        lvitem_aux = listView1.Items[aux_int];
                        lvitem_aux.SubItems[0].Text = (aux_int + 1).ToString();

                    }//for

                }
                else
                {
                    MessageBox.Show("ERROR: No hay partido seleccionado");
                }//if
            
            }//if

        }

        private void button5_Click(object sender, EventArgs e)
        {
            int aux_int;
            ListViewItem lvitem_aux;

            // si pulsan el Button "Borrar" y hay algun elemento de la ListView seleccionado lo eliminamos
            if (listView1.SelectedItems.Count > 0)
            {
                // se borra el elemento
                listView1.Items.RemoveAt(listView1.SelectedIndices[0]);

                // actualizamos el valor de los indices ( el numero que aparecene en la 1a columna )
                for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
                {                    
                    lvitem_aux = listView1.Items[aux_int];
                    lvitem_aux.SubItems[0].Text = (aux_int+1).ToString();

                }//for
    
            }
            else
            {
                MessageBox.Show("ERROR: No hay partido seleccionado");
            }//if

        }


    }
}