using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    public partial class Form3 : Form
    {
        public enum resultado { Uno = 1, Dos = 2, Equis = 3 };
        public enum tipo_test { P_Con_Fact_Campo = 1, P_Sin_Fact_campo = 2 };
        public enum tipo_grafico { Barras = 1, BarrasGruesas = 2, Lineas = 3 };

        informacion_grafica_test_metodos grafica = new informacion_grafica_test_metodos();

        // bitmap donde pintaremos los graficos, asi seran persistentes, es decir no se borraran al mover los formularios etc.
        private System.Drawing.Bitmap bitmap_con_graficos; 

        List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los nombres de todas las temporadas
        List<int> Lista_Temporadas_Id = new List<int>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los IDs de todas las temporadas            


        // parametros bsicos de los grficos

        // grafico 1
        int ancho_grafico_1 = 650;
        int alto_grafico_1 = 100;
        int origenx_grafico_1 = 50;
        int origeny_grafico_1 = 30;

        // grafico 2
        int ancho_grafico_2 = 650;
        int alto_grafico_2 = 100;
        int origenx_grafico_2 = 50;
        int origeny_grafico_2 = 195;

        public Form3(){            
            InitializeComponent();
        }


        /*Description:
        *   Funcion que realiza un test sobre el metodo de analisis indicado en tipo_test obteniendo las
        *   probabilidades de acierto del metodo.
        * Recives:
        *   Por valor:
        *      tipo_test: con el tipo de test que queremos poner a prueba
        * Returns:
        */
        private void AplicaTestAnalisis(tipo_test tipo_a_probar, Analizador.tipo_division division, int id_temporada_origen, int id_temporada_fin)
        {
            List<int> Lista_Temporadas_Id = new List<int>();
            List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();
            List<int> Lista_Jornadas = new List<int>();

            List<string> Lista_Equipo1 = new List<string>();
            List<int> Lista_Goles_Equipo1 = new List<int>();
            List<string> Lista_Equipo2 = new List<string>();
            List<int> Lista_Goles_Equipo2 = new List<int>();

            Random GeneradorAleatorio = new Random();
            int total_temporadas = 0;
            int total_jornadas = 0;
            int total_partidos_jornada = 0;
            int maximo_total_partidos_jornada = 0; // guarda el numero de partidos que hay en una jornada de la temporada con mas partidos por jornada
            resultado resultado_real = resultado.Uno;
            resultado resultado_predecido = resultado.Uno;
            int aciertos_jornada = 0;

            int[] array_frecuencia_aciertos_temporada = new int[informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA];
            int[] array_frecuencia_aciertos_totales = new int[informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA];
            float[] array_p_aciertos = new float[informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA];
            
            int jornadas_temporada_analizadas = 0;
            int jornadas_totales_analizadas = 0;
            
            string aux_string;
            string aux_string2;
            string aux_string3;
            string aux_string4;
            float aux_float;

            // principalmente se usan para llamar a la funcion de probabilidades
            int victorias_uno = 0;
            int goles_uno = 0;
            float unos = 0;
            float equis = 0;
            float doses = 0;
            int goles_dos = 0;
            int victorias_dos = 0;
            int empates = 0;
            int total_partidos = 0;            

            // variables auxiliares
            int aux_int = 0;
            int aux_int2 = 0;
            int aux_int3 = 0;
            int aux_int4 = 0;
            double double_aux;


            // inicializa todo el array en que se guardan los aciertos totales acumulados a lo largo de las diferentes temporadas
            for (aux_int4 = 0; aux_int4 < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int4++)
            {
                array_frecuencia_aciertos_totales[aux_int4] = 0;
            }//for

            // obtenemos el total de temporadas de la BBDD
            Lista_Temporadas_Id.Clear();
            Lista_Temporadas_Anio1_Anio2.Clear();
            total_temporadas = Analizador.ConsultaRangoTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2, division,id_temporada_origen,id_temporada_fin);

            // antes de aplicar el algoritmo comprobamos que hay temporadas que cumplen el criterio establecido
            if (total_temporadas==0){

                // no hay temporadas que cumplan el criterio establecido, se puede producir pq no hayan temporadas de alguna de las divisiones especificadas ( con toda 
                // certeza sera que la consulta de temporadas de 2a division ha retornado 0 temporadas, ya que de 1a tenemos todas las temporadas de la combo de seleccion )
                MessageBox.Show("ERROR: no hay temporadas que cumplan el criterio establecido");
            
            }else{
                
                // s que hay temporadas que cumplen el criterio establecido

                // solo hace que se muestre por pantalla el mensaje general de inicio de test
                switch (tipo_a_probar)
                {
                    case tipo_test.P_Con_Fact_Campo:
                        textBox1.Text = textBox1.Text + "Iniciado test del Metodo de Analisis con Factor Campo\r\n";
                        break;
                    case tipo_test.P_Sin_Fact_campo:
                        textBox1.Text = textBox1.Text + "Iniciado test del Metodo de Analisis sin Factor Campo\r\n";
                        break;
                    default:
                        textBox1.Text = textBox1.Text + "ATENCION: Metodo de analisi erroneo\r\n";
                        break;
                }//switch                

                textBox1.Text = textBox1.Text + "ATENCION: recordar que los valores obtenidos son slo aproximaciones ( consultar ayuda on-line )\r\n";

                // solo muestra por pantalla el mensaje indicando cuantas y que temporadas se van a analizar
                switch (division){
                    case Analizador.tipo_division.Primera:
                        textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString()+" temporadas de 1a division ( de "+ Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] +" a "+Lista_Temporadas_Anio1_Anio2[0]+")\r\n";
                        break;
                    case Analizador.tipo_division.Segunda:
                        textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString() + " temporadas de 2a division ( de " + Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] + " a " + Lista_Temporadas_Anio1_Anio2[0] + ")\r\n";
                        break;
                    case Analizador.tipo_division.PrimeraSegunda:
                        textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString() + " temporadas de 1a y 2a division (de " + Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] + " a " + Lista_Temporadas_Anio1_Anio2[0] + ")\r\n";
                        break;
                    default:
                        break;
                }//switch

                maximo_total_partidos_jornada = 0;
                for (aux_int = 0; aux_int < total_temporadas;aux_int++){

                    // inicializa el array en que se guardan los aciertos de la temporada
                    for (aux_int4 = 0; aux_int4 < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int4++)
                    {
                        array_frecuencia_aciertos_temporada[aux_int4] = 0;                
                    }//for

                    // para cada temporada obtenemos el total de jornadas
                    Lista_Jornadas.Clear();
                    total_jornadas = Analizador.ConsultaNumJornadasTemporada(Lista_Temporadas_Id[aux_int], Lista_Jornadas, division);
                    jornadas_temporada_analizadas = 0;
                    for (aux_int2 = 0; aux_int2 < total_jornadas; aux_int2++){

                        // para cada jornada obtenemos los partidos que se jugaron y sus resultados            
                        Lista_Equipo1.Clear();
                        Lista_Equipo2.Clear();
                        Lista_Goles_Equipo1.Clear();
                        Lista_Goles_Equipo2.Clear();
                        aciertos_jornada = 0;
                        
                        // cuando se combinan 1a y 2a division es posible que total_partidos_jornada varie en las ultimas jorndas puesto que 1a tiene menos jornadas que 2a, por eso el ultimo valor
                        // obtenido en total_partidos_jornada no tiene porque corresponderse con el numero de partidos por jornada de 1a y 2a division del resto de jornadas de la liga, puesto que la 1a 
                        // divison tienen menos jornadas y por tanto termina antes, por lo que la ulitma jornada de liga solo tiene partidos de 2a y el numeor de partidos en esa jornada es solo los de 2a
                        total_partidos_jornada = Analizador.ConsultaPartidosJornada(Lista_Temporadas_Id[aux_int], Lista_Jornadas[aux_int2], Lista_Equipo1, Lista_Equipo2, Lista_Goles_Equipo1, Lista_Goles_Equipo2, division);

                        // revisamos la variable que usamos para printar por pantalla cual es el numero de partidos por jornada (tenemos que informar del mayor puesto que algunas jornadas no tienen partidos )
                        if (total_partidos_jornada > maximo_total_partidos_jornada) { maximo_total_partidos_jornada = total_partidos_jornada; }                                       
                        for (aux_int3 = 0; aux_int3 < total_partidos_jornada; aux_int3++){

                            // calculamos las probabilidades del resultado llamando a la correspondiente funcion de analisis
                            switch (tipo_a_probar){

                                case tipo_test.P_Con_Fact_Campo:
                                    // aplicamos el metodo de Analisis P Con Factor Campo
                                    Analizador.ProbabilidadConFactorCampo(Lista_Equipo1[aux_int3], Lista_Equipo2[aux_int3], Lista_Temporadas_Id[0], Lista_Temporadas_Id[Lista_Temporadas_Id.Count - 1], ref victorias_uno, ref goles_uno, ref unos, ref equis, ref doses, ref goles_dos, ref victorias_dos, ref empates, ref total_partidos);
                                    if ((unos > doses) && (unos > equis)){
                                        resultado_predecido = resultado.Uno;
                                    }else if ((doses > unos) && (doses > equis)){
                                        resultado_predecido = resultado.Dos;
                                    }else{
                                        resultado_predecido = resultado.Equis;
                                    }//if
                                    break;

                                case tipo_test.P_Sin_Fact_campo:
                                    // aplicamos el metodo de Analisis B
                                    Analizador.ProbabilidadSinFactorCampo(Lista_Equipo1[aux_int3], Lista_Equipo2[aux_int3], Lista_Temporadas_Id[0], Lista_Temporadas_Id[Lista_Temporadas_Id.Count-1], ref victorias_uno, ref goles_uno, ref unos, ref equis, ref doses, ref goles_dos, ref victorias_dos, ref empates, ref total_partidos);
                                    if ((unos > doses) && (unos > equis)){
                                        resultado_predecido = resultado.Uno;
                                    }else if ((doses > unos) && (doses > equis)){
                                        resultado_predecido = resultado.Dos;
                                    }else{
                                        resultado_predecido = resultado.Equis;
                                    }//if
                                    break;

                                default:
                                    break;
                            }//switch

                            // calculamos el resutlado real es decir, si en el partido real salio 1, X o 2
                            if (Lista_Goles_Equipo1[aux_int3] > Lista_Goles_Equipo2[aux_int3]){
                                resultado_real = resultado.Uno;
                            }else if ((Lista_Goles_Equipo1[aux_int3] < Lista_Goles_Equipo2[aux_int3])){
                                resultado_real = resultado.Dos;
                            }else{
                                resultado_real = resultado.Equis;
                            }//if

                            // comparamos el resultado real con el predecido
                            if (resultado_real == resultado_predecido){
                                aciertos_jornada++;
                            }//if
                            
                        }//for
                        array_frecuencia_aciertos_temporada[aciertos_jornada]++;
                        jornadas_temporada_analizadas++;
                        jornadas_totales_analizadas++;
                   
                    }//for
                    
                    // aadimos los aciertos de la temporada a los aciertos totales
                    for (aux_int4 = 0; aux_int4 < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int4++)
                    {
                        array_frecuencia_aciertos_totales[aux_int4] = array_frecuencia_aciertos_totales[aux_int4] + array_frecuencia_aciertos_temporada[aux_int4];
                    }//for

                    // si esta seleccionada la opcion dibujamos el grafico de distribucion de la probabilidad de la temporada que se acaba de procesar
                    if (checkBox1.Checked==true){

                        for (aux_int4 = 0; aux_int4 < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int4++){
                            array_p_aciertos[aux_int4] = (float)((float)array_frecuencia_aciertos_temporada[aux_int4] / (float)jornadas_temporada_analizadas);
                        }//for
                        DibujaProbabilidad(array_p_aciertos, tipo_grafico.Barras, Color.Black);
                        DibujaProbabilidadAcumulada(array_p_aciertos, tipo_grafico.Barras, Color.Black);
                        
                        //tras dibujar cada temporada refrescamos el lienzo
                        Refresh();
                        
                    }//if
                    
                    // printamos los aciertos de la temporada
                    // textBox1.Text = textBox1.Text + "Temporada:" + Lista_Temporadas_Anio1_Anio2[aux_int] + "\r\n";
                    // for (aux_int4 = 0; aux_int4 < MAX_COMBINACIONES_JORNADA; aux_int4++){
                    //    textBox1.Text = textBox1.Text + aux_int4 + " aciertos " + array_frecuencia_aciertos_temporada[aux_int4].ToString() + " veces \r\n";
                    //    array_frecuencia_aciertos_totales[aux_int4] = array_frecuencia_aciertos_totales[aux_int4] + array_frecuencia_aciertos_temporada[aux_int4];
                    //}//for

                    // muestra el texto informativo por pantalla indicando los caluclos que se van a realizar
                    switch (division)
                    {
                        case Analizador.tipo_division.Primera:
                        case Analizador.tipo_division.Segunda:
                            // en el caso de calcular solo sobre los encuentros de 1a division o de 2a division, todas las jornadas tendran igual numero de encuentros
                            textBox1.Text = textBox1.Text + "Analizadas las " + total_jornadas.ToString() + " jornadas de la temporada " + Lista_Temporadas_Anio1_Anio2[aux_int] + " ( " + maximo_total_partidos_jornada.ToString() + " partidos por jornada )\r\n"; ;
                            break;
                        case Analizador.tipo_division.PrimeraSegunda:
                            // en el caso de calcular sobre encuentros de 1a y de 2a division, sucedera que, como la liga de 2a division tiene mas jornadas, las ultimas jornadas analizadas
                            // tendran menos partidos que las primeras, puesto que las primeras tendran partidos de 1a y de 2a mientras que las ultimas solo de 2a
                            textBox1.Text = textBox1.Text + "Analizadas las " + total_jornadas.ToString() + " jornadas de la temporada " + Lista_Temporadas_Anio1_Anio2[aux_int] + " ( hasta " + maximo_total_partidos_jornada.ToString() + " partidos por jornada )\r\n"; ;
                            break;
                        default:
                            break;
                    }//switch                    
                    
                    Application.DoEvents();

                }//for

                // dibujamos el grafico de distribucion de la probabilidad media lo largo de las temporadas analizadas
                // pero antes rellenamos el array que toque con los valores calculados para luego poder pintar la grafica
                for (aux_int4 = 0; aux_int4 < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int4++)
                {
                    // en funcion del tipo de test acutalizamos un array de valores u otro
                    switch (tipo_a_probar){
                        case tipo_test.P_Con_Fact_Campo:
                            grafica.array_p_aciertos_con_factor_campo[aux_int4] = (float)((float)array_frecuencia_aciertos_totales[aux_int4] / (float)jornadas_totales_analizadas);
                            break;
                        case tipo_test.P_Sin_Fact_campo:
                            grafica.array_p_aciertos_sin_factor_campo[aux_int4] = (float)((float)array_frecuencia_aciertos_totales[aux_int4] / (float)jornadas_totales_analizadas);
                            break;
                        default:
                            break;
                    }//switch                

                }//for

                // dibujamos la grafica final de un color u otro dependiendo del tipo de test escogido
                switch (tipo_a_probar){
                    case tipo_test.P_Con_Fact_Campo:
                        DibujaProbabilidad(grafica.array_p_aciertos_con_factor_campo, tipo_grafico.BarrasGruesas, Color.Red);
                        DibujaProbabilidadAcumulada(grafica.array_p_aciertos_con_factor_campo, tipo_grafico.BarrasGruesas, Color.Red);
                        grafica.array_factor_campo_inicializado = true; // sealizamos tambien el flag que indica que el array tiene valores
                        break;
                    case tipo_test.P_Sin_Fact_campo:
                        DibujaProbabilidad(grafica.array_p_aciertos_sin_factor_campo, tipo_grafico.BarrasGruesas, Color.Yellow);
                        DibujaProbabilidadAcumulada(grafica.array_p_aciertos_sin_factor_campo, tipo_grafico.BarrasGruesas, Color.Yellow);
                        grafica.array_sin_factor_campo_inicializado = true; // sealizamos tambien el flag que indica que el array tiene valores
                        break;
                    default:
                        break;
                }//switch

                //tras dibujar la grafica final refrescamos el lienzo
                Refresh();

                // se muestran por pantalla los aciertos totales
                switch (tipo_a_probar){
                    case tipo_test.P_Con_Fact_Campo:
                        textBox1.Text = textBox1.Text + "Probabilidad media de aciertos en el test del Analisis A:\r\n";
                        break;
                    case tipo_test.P_Sin_Fact_campo:
                        textBox1.Text = textBox1.Text + "Probabilidad media de aciertos en el test del Analisis B:\r\n";
                        break;
                    default:
                        textBox1.Text = textBox1.Text + "ERROR: el tipo de analsis es incorrecto!\r\n";
                        break;
                }//switch
             
                // se muestra por pantalla la probabilidad media por numero de aciertos
                for (aux_int4 = 0; aux_int4 <= maximo_total_partidos_jornada; aux_int4++)
                {
                    aux_string = String.Format("{0:00.00}", (((float)array_frecuencia_aciertos_totales[aux_int4] / (float)jornadas_totales_analizadas)*100) );
                    aux_string2 = String.Format("{0:00}", aux_int4);
                    aux_string3 = String.Format("{0:000}", array_frecuencia_aciertos_totales[aux_int4]);
                    double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                    aux_string4 = String.Format("{0:00.0}", double_aux);
                    textBox1.Text = textBox1.Text + aux_string2 + " aciertos " + aux_string3 + "/" + jornadas_totales_analizadas.ToString() + " ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";
                }//for

                // se muestran por pantalla las probabilidades acumuladas
                switch (tipo_a_probar)
                {
                    case tipo_test.P_Con_Fact_Campo:
                        textBox1.Text = textBox1.Text + "Probabilidad acumulada de los aciertos en el test del Analisis A:\r\n";
                        break;
                    case tipo_test.P_Sin_Fact_campo:
                        textBox1.Text = textBox1.Text + "Probabilidad acumulada de los aciertos en el test del Analisis B:\r\n";
                        break;
                    default:
                        textBox1.Text = textBox1.Text + "ERROR: el tipo de analsis es incorrecto!\r\n";
                        break;
                }//switch

                // se muestra por pantalla la probabilidad acumulada por numero de aciertos
                aux_float = 1;
                for (aux_int4 = 0; aux_int4 <maximo_total_partidos_jornada; aux_int4++)
                {
                    aux_float = aux_float - ((float)array_frecuencia_aciertos_totales[aux_int4] / (float)jornadas_totales_analizadas);
                    aux_string = String.Format("{0:000.00}", (aux_float * 100));
                    aux_string2 = String.Format("{0:00}", aux_int4);
                    aux_string3 = String.Format("{0:000}", array_frecuencia_aciertos_totales[aux_int4]);
                    double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                    aux_string4 = String.Format("{0:00.0}", double_aux);
                    textBox1.Text = textBox1.Text  + "Ms de "+aux_string2 + " aciertos ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";
                }//for

                textBox1.Text = textBox1.Text + "Fin del test\r\n";

            }//if total temporadas==0

        }//AplicaTestAnalisis



        /*Description:
         *   Procedimiento que dibuja los ejes de coordenadas y la escala
         * Recives:
         * Returns:
         */
        private void DibujaEjesProbabilidad(){
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);         
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 10);
            SolidBrush brocha = new SolidBrush(Color.Black);            
            
            int x, y;
            int ancho_barra;

            int aux_int;

           
            // dibuja el eje de coordenadas X y el Y
            ancho_barra = ancho_grafico_1 /informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
            brocha.Color = Color.Black;
            lienzo.DrawRectangle(pincel, origenx_grafico_1, origeny_grafico_1, ancho_grafico_1, alto_grafico_1);
            

            // printa la escala del eje X            
            y = origeny_grafico_1 + alto_grafico_1;
            for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
            {
                x = origenx_grafico_1 + (ancho_barra*aux_int) + (int)(ancho_barra / 2);
                lienzo.DrawString(aux_int.ToString(), drawFont, brocha, x - 4, y + 7);
            }//for
            
            // printa la escala del eje Y
            // 0
            x = origenx_grafico_1;
            y = origeny_grafico_1 + alto_grafico_1;
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_1, y);
            lienzo.DrawString("0", drawFont, brocha, x - 40, y - 10);

            // 0,25
            y = origeny_grafico_1 + alto_grafico_1 - (int)(alto_grafico_1 * 0.25);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_1, y);
            lienzo.DrawString("0,25", drawFont, brocha, x - 40, y - 10);

            // 0,5
            y = origeny_grafico_1 + alto_grafico_1 - (int)(alto_grafico_1 * 0.5);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_1, y);
            lienzo.DrawString("0,5", drawFont, brocha, x - 40, y - 10);

            // 0,75
            y = origeny_grafico_1 + alto_grafico_1 - (int)(alto_grafico_1 * 0.75);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_1, y);
            lienzo.DrawString("0,75", drawFont, brocha, x - 40, y - 10);

            // 1
            x = origenx_grafico_1;
            y = origeny_grafico_1 + alto_grafico_1 - (int)(alto_grafico_1);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_1, y);
            lienzo.DrawString("1", drawFont, brocha, x - 40, y - 5);

        }//DibujaEjesGraficaFrecuencia


        /*Description:
           Procedimiento que dibuja los ejes de coordenadas y la escala
        * Recives:
        * Returns:
        */
        private void DibujaEjesProbabilidadAcumulada()
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);       
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 10);
            SolidBrush brocha = new SolidBrush(Color.Black);
            int x, y;
            int ancho_barra;

            int aux_int;


            // dibuja el eje de coordenadas X y el Y
            ancho_barra = ancho_grafico_2 / informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
            brocha.Color = Color.Black;
            lienzo.DrawRectangle(pincel, origenx_grafico_2, origeny_grafico_2, ancho_grafico_2, alto_grafico_2);

            // printa la escala del eje X            
            y = origeny_grafico_2 + alto_grafico_2;
            for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
            {
                x = origenx_grafico_2 + (ancho_barra * aux_int) + (int)(ancho_barra / 2);
                lienzo.DrawString(aux_int.ToString(), drawFont, brocha, x - 4, y + 7);
            }//for

            // printa la escala del eje Y
            // 0
            x = origenx_grafico_2;
            y = origeny_grafico_2 + alto_grafico_2;
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_2, y);
            lienzo.DrawString("0", drawFont, brocha, x - 40, y - 10);

            // 0,25
            y = origeny_grafico_2 + alto_grafico_2 - (int)(alto_grafico_2 * 0.25);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_2, y);
            lienzo.DrawString("0,25", drawFont, brocha, x - 40, y - 10);

            // 0,5
            y = origeny_grafico_2 + alto_grafico_2 - (int)(alto_grafico_2 * 0.5);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_2, y);
            lienzo.DrawString("0,5", drawFont, brocha, x - 40, y - 10);

            // 0,75
            y = origeny_grafico_2 + alto_grafico_2 - (int)(alto_grafico_2 * 0.75);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_2, y);
            lienzo.DrawString("0,75", drawFont, brocha, x - 40, y - 10);

            // 1
            x = origenx_grafico_2;
            y = origeny_grafico_2 + alto_grafico_2 - (int)(alto_grafico_2);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico_2, y);
            lienzo.DrawString("1", drawFont, brocha, x - 40, y - 5);

        }//DibujaEjesGraficaAcumulada



        /*Description:
        *   Funcion que recibe un array con las probabilidades de cada numero de aciertos y los dibuja
        * Recives:
        *   Por referencia:
        * Returns:
        */
        private void DibujaProbabilidad(float[] array_p_aciertos, tipo_grafico estilo_del_grafico, Color color)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);       
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);

            int aux_int;
            int x, y;
            int ancho_barra;
            int alto_barra;

            // dibuja el eje de coordenadas
            DibujaEjesProbabilidad();

            // se dibuna un tipo de grafico un otro en funcion del valor recibido en estilo_del_grafico
            switch (estilo_del_grafico){

                case tipo_grafico.Barras:

                    // dibuja las barras
                    pincel.Color = color;
                    ancho_barra = ancho_grafico_2 / informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
                    for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
                    {

                        alto_barra = (int)(alto_grafico_2 * array_p_aciertos[aux_int]);
                        x = origenx_grafico_2 + (ancho_barra * aux_int);
                        y = origeny_grafico_2 + alto_grafico_2 - alto_barra;
                        lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);

                    }//for
                    break;

                case tipo_grafico.BarrasGruesas:

                    // dibuja las barras                    
                    pincel.Color = color;
                    pincel.Width = 3;
                    ancho_barra = ancho_grafico_2 / informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
                    for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
                    {

                        // dibuja las barras
                        alto_barra = (int)(alto_grafico_2 * array_p_aciertos[aux_int]);
                        x = origenx_grafico_2 + (ancho_barra * aux_int);
                        y = origeny_grafico_2 + alto_grafico_2 - alto_barra;
                        lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);

                    }//for
                    break;

                default:

                    break;

            }//switch

        }//DibujaProbabilidadAciertos


        /*Description:
        *   Funcion que recibe un array con las probabilidades de cada numero de aciertos y los dibuja
        * Recives:
        *   Por referencia:
        * Returns:
        */
        private void DibujaProbabilidadAcumulada(float[] array_p_aciertos, tipo_grafico estilo_del_grafico, Color color)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);       
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);
            int aux_int;
            int x, y;
            int ancho_barra;
            int alto_barra;
            float p_acumulada;

            // dibuja el eje de coordenadas
            DibujaEjesProbabilidadAcumulada();

            // se dibuna un tipo de grafico un otro en funcion del valor recibido en estilo_del_grafico
            switch (estilo_del_grafico)
            {

                case tipo_grafico.Barras:

                    // dibuja las barras
                    pincel.Color = color;
                    ancho_barra = ancho_grafico_1 / informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
                    p_acumulada = 1;
                    for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
                    {
                        p_acumulada = p_acumulada - array_p_aciertos[aux_int];
                        alto_barra = (int)(alto_grafico_1 * p_acumulada);
                        x = origenx_grafico_1 + (ancho_barra * aux_int);
                        y = origeny_grafico_1 + alto_grafico_1 - alto_barra;
                        lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);

                    }//for
                    break;

                case tipo_grafico.BarrasGruesas:

                    // dibuna las barras                    
                    pincel.Color = color;
                    pincel.Width = 3;
                    ancho_barra = ancho_grafico_1 / informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA;
                    p_acumulada = 1;
                    for (aux_int = 0; aux_int < informacion_grafica_test_metodos.MAX_COMBINACIONES_JORNADA; aux_int++)
                    {
                        p_acumulada = p_acumulada - array_p_aciertos[aux_int];
                        // dibuja las barras
                        alto_barra = (int)(alto_grafico_1 * p_acumulada);
                        if (alto_barra <= 2) { alto_barra = 0; } // si la barra queda de 1 o 2 pixel de alto ni la dibujamos
                        x = origenx_grafico_1 + (ancho_barra * aux_int);
                        y = origeny_grafico_1 + alto_grafico_1 - alto_barra;
                        lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);

                    }//for
                    break;

                default:

                    break;

            }//switch

        }//DibujaAcumulada


        /*Description:
        *   Funcion que pinta todos los graficos del formulario
        * Recives:
        *   Por referencia:
        * Returns:
        */
        private void DibujaTodo()
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);         

            // si esta activado el checkbox borrar al refrescar borramos todo
            if (checkBox2.Checked==true ){
                lienzo.Clear(Form3.DefaultBackColor);
            }

            // pintamos los ejes
            DibujaEjesProbabilidad();
            DibujaEjesProbabilidadAcumulada();

            // dibuja las graficas con los resultados del test de azar puro    
            if (grafica.array_azar_puro_inicializado == true)
            {
                DibujaProbabilidad(grafica.array_p_aciertos_azar_puro, tipo_grafico.BarrasGruesas, Color.BlueViolet);
                DibujaProbabilidadAcumulada(grafica.array_p_aciertos_azar_puro, tipo_grafico.BarrasGruesas, Color.BlueViolet);
            }

            // dibuja las graficas con los resultados del test de tipo A   
            if (grafica.array_factor_campo_inicializado == true)
            {
                DibujaProbabilidad(grafica.array_p_aciertos_con_factor_campo, tipo_grafico.BarrasGruesas, Color.Red);
                DibujaProbabilidadAcumulada(grafica.array_p_aciertos_con_factor_campo, tipo_grafico.BarrasGruesas, Color.Red);
            }

            // dibuja las graficas con los resultados del test de tipo B  
            if (grafica.array_sin_factor_campo_inicializado == true)
            {
                DibujaProbabilidad(grafica.array_p_aciertos_sin_factor_campo, tipo_grafico.BarrasGruesas, Color.Yellow);
                DibujaProbabilidadAcumulada(grafica.array_p_aciertos_sin_factor_campo, tipo_grafico.BarrasGruesas, Color.Yellow);
            }
        }//DibujaTodo


        private void button1_Click(object sender, EventArgs e)
        {

            // se inicializa el array con las graficas
            grafica.inicializa();
            // pintamos en el lienzo
            DibujaTodo();
            // forzamos la llamada al metodo Paint()
            Refresh();

            if (radioButton1.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Con_Fact_Campo, Analizador.tipo_division.Primera, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }else if (radioButton2.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Con_Fact_Campo, Analizador.tipo_division.Segunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }else if (radioButton3.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Con_Fact_Campo, Analizador.tipo_division.PrimeraSegunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }//if

        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            // se inicializa el array con las graficas
            grafica.inicializa();
            // pintamos en el lienzo
            DibujaTodo();
            // forzamos la llamada al metodo Paint()
            Refresh();

            if (radioButton1.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Sin_Fact_campo, Analizador.tipo_division.Primera, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }else if (radioButton2.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Sin_Fact_campo, Analizador.tipo_division.Segunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }else if (radioButton3.Checked == true){
                AplicaTestAnalisis(tipo_test.P_Sin_Fact_campo, Analizador.tipo_division.PrimeraSegunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }//if

        }


        private void button2_GotFocus(Object sender, EventArgs e)
        {

            MessageBox.Show("You are in the Control.GotFocus event.");

        }


        private void Form3_Load(object sender, EventArgs e)
        {
            int total_temporadas;
            int int_aux;

            // se llenan las ComboBoxes con todas las temporadas disponibles 
            total_temporadas = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (int_aux = 0; int_aux < total_temporadas; int_aux++)
            {
                comboBox1.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);
                comboBox2.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);
            }//for
            // inicializamos con la primera y ulima temporada
            comboBox1.Text = Lista_Temporadas_Anio1_Anio2[total_temporadas - 1].ToString();
            comboBox2.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();

            // creamos el bitmap que sera el lienzo donde dibujaremos pintamos ( en l para tener persistencia de la imagen sino al mover los forms, se borran )
            bitmap_con_graficos = new Bitmap(this.ClientRectangle.Width, this.ClientRectangle.Height, System.Drawing.Imaging.PixelFormat.Format24bppRgb);

            // pintamos en el lienzo
            DibujaTodo();

            // forzamos la llamada al metodo Paint()
            Refresh();

        }


        private void button2_Click(object sender, EventArgs e)
        {
        }

        private void button3_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void button6_Click(object sender, EventArgs e)
        {
            // han pulsado el boton refrescar asi que limpiamos y repintamos todo
            
            // pintamos en el lienzo
            DibujaTodo();
            // forzamos la llamada al metodo Paint()
            Refresh();
        }

        private void Form3_FormClosing(object sender, FormClosingEventArgs e)
        {
            LFSuite.Form1 FormPadre = (LFSuite.Form1)this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_test_prediccion = null;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            // cerramos el formulario ( se llamara al evento closing que gestiona el tema del puntero en el parent etc.)
            this.Close();
        }

        private void Form3_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphicsObj = e.Graphics;

            graphicsObj.DrawImage(bitmap_con_graficos, 0, 0, bitmap_con_graficos.Width, bitmap_con_graficos.Height);

            graphicsObj.Dispose();

        }

    }

    class informacion_grafica_test_metodos
    {

        public const int MAX_COMBINACIONES_JORNADA = 24;
        public const int MAX_RANGO_INTERVALOS_RELATIVOS = 20;
        public bool array_azar_puro_inicializado;// para saber si hay datos validos en el array de azar puro
        public float[] array_p_aciertos_azar_puro = new float[MAX_COMBINACIONES_JORNADA];
        public bool array_factor_campo_inicializado;// para saber si hay datos validos en el array de tipo a
        public float[] array_p_aciertos_con_factor_campo = new float[MAX_COMBINACIONES_JORNADA];
        public bool array_sin_factor_campo_inicializado;// para saber si hay datos validos en el array de tipo b
        public float[] array_p_aciertos_sin_factor_campo = new float[MAX_COMBINACIONES_JORNADA];

        public informacion_grafica_test_metodos()
        {
            uint ui_aux;

            for (ui_aux = 0; ui_aux < MAX_COMBINACIONES_JORNADA; ui_aux++){
                array_p_aciertos_azar_puro[ui_aux] = 0;
                array_p_aciertos_con_factor_campo[ui_aux] = 0;
                array_p_aciertos_sin_factor_campo[ui_aux] = 0;
            }//for
            
            // indicamos que los arrays no tienen valores validos
            array_azar_puro_inicializado = false;
            array_factor_campo_inicializado = false;
            array_sin_factor_campo_inicializado = false;

        }

        public void inicializa()
        {
            uint ui_aux;

            for (ui_aux = 0; ui_aux < MAX_COMBINACIONES_JORNADA; ui_aux++)
            {
                array_p_aciertos_azar_puro[ui_aux] = 0;
                array_p_aciertos_con_factor_campo[ui_aux] = 0;
                array_p_aciertos_sin_factor_campo[ui_aux] = 0;
            }//for

            // indicamos que los arrays no tienen valores validos
            array_azar_puro_inicializado = false;
            array_factor_campo_inicializado = false;
            array_sin_factor_campo_inicializado = false;

        }


    }//informacion_grafica_test_metodos

}