using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    public partial class Form4 : Form
    {
        private ListViewColumnSorter_Form4 lvwColumnSorter;// para poder ordenar la ViewList

        // se utiliza para guardar los nombres de los equipos ( y sus Ids ) que vamos a insertar en la ComboBox
        List<string> ListaEquiposEquipo = new List<string>();
        List<int> ListaEquiposId = new List<int>();

        // se utilizan para guardar la informacin de todas las temporadas que se insertara en la ComboBox y sus identificadores
        List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();
        List<int> Lista_Temporadas_Id = new List<int>();
 
        public Form4()
        {
            InitializeComponent();
            // aadido para permitir la ordenacion de las columnas
            lvwColumnSorter = new ListViewColumnSorter_Form4();
            this.listView1.ListViewItemSorter = lvwColumnSorter;
        }

        private void Form4_Load(object sender, EventArgs e)
        {
            int aux_int;
            int aux_int2;            
            int total_temporadas;

            // al cargar el formulario se llenan las combo boxes correspondientes con los equipos contenidos en la BBDD
            aux_int = Analizador.ConsultaEquipos(ListaEquiposId, ListaEquiposEquipo);

            ListaEquiposEquipo.Sort(); // OJO al ordenar: se nos desparejara la correspondencia entre los arryas de Ids y de Nombres Equipos!!
            for (aux_int2 = 0; aux_int2 < aux_int; aux_int2++)
            {
                comboBox1.Items.Add(ListaEquiposEquipo[aux_int2]);
                comboBox2.Items.Add(ListaEquiposEquipo[aux_int2]);
            }//for

            // se llenan las ComboBoxes correspondientes con la informacin de las temporadas
            total_temporadas = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (aux_int = 0; aux_int < total_temporadas; aux_int++)
            {
                comboBox3.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
                comboBox4.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
            }//for

            // inicializamos las ComboBoxes de temporada con la primera y ulima temporada
            comboBox3.Text = Lista_Temporadas_Anio1_Anio2[total_temporadas - 1].ToString();
            comboBox4.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();

            // inicializamos la View List con los campos pertinentes
            listView1.Clear();
            listView1.View = View.Details;// para que se vean los detalles nombre de columna etc

            listView1.Columns.Add("N", 35, HorizontalAlignment.Center);
            listView1.Columns.Add("Temporada", 75, HorizontalAlignment.Center);
            listView1.Columns.Add("Divisin", 60, HorizontalAlignment.Center); 
            listView1.Columns.Add("Fecha", 75, HorizontalAlignment.Center);
            listView1.Columns.Add("N Jor.", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("Local", 75, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("Visitante", 75, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles", 50, HorizontalAlignment.Center);
            listView1.Columns.Add("1 X 2", 45, HorizontalAlignment.Center);
            listView1.Columns.Add("Victoria",60, HorizontalAlignment.Center);

            // inicializamos la View List2 con los campos pertinentes
            listView2.Clear();
            listView2.View = View.Details;// para que se vean los detalles nombre de columna etc

            listView2.Columns.Add("Equipo", 90, HorizontalAlignment.Center);
            listView2.Columns.Add("G. marcados", 80, HorizontalAlignment.Center);
            listView2.Columns.Add("G. marc. / partido", 105, HorizontalAlignment.Center);
            listView2.Columns.Add("G. encajados", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("G. encaj. / partido", 110, HorizontalAlignment.Center);
            listView2.Columns.Add("Victorias", 60, HorizontalAlignment.Center);
            listView2.Columns.Add("P. victoria", 80, HorizontalAlignment.Center);
            listView2.Columns.Add("Empates", 65, HorizontalAlignment.Center);
            listView2.Columns.Add("P. empate", 80, HorizontalAlignment.Center);
            listView2.Columns.Add("Derrotas", 60, HorizontalAlignment.Center);
            listView2.Columns.Add("P. derrota", 80, HorizontalAlignment.Center);
            listView2.Columns.Add("P. analizados", 90, HorizontalAlignment.Center);
        }

        private void button2_Click(object sender, EventArgs e)
       { 
            
            List<string> Lista_temporada = new List<string>();
            List<string> Lista_fecha = new List<string>();
            List<int> Lista_jornada = new List<int>();
            List<int> Lista_ids_eq_local = new List<int>();
            List<int> Lista_ids_eq_visitante = new List<int>();
            List<int> Lista_goles_eq_local = new List<int>();
            List<int> Lista_goles_eq_visitante = new List<int>();
            List<int> Lista_division_encuentro = new List<int>();

            int local_goles_marcados;
            int visitante_goles_marcados ;
            int local_goles_encajados;
            int visitante_goles_encajados;
            int partidos_analizados;
            int local_victorias;
            int local_empates;
            int local_derrotas;
            int visitante_victorias;
            int visitante_empates;
            int visitante_derrotas;
            string equipo_local_partido;
            string equipo_visitante_partido;
            string equipo_victoria;

            ListViewItem lvitem_aux;            

            int int_aux1;
            int int_aux2;

            float float_aux;

            int id_eq_local;
            int id_eq_visitante;

            // antes de nada comprobamos que haya algun equipo seleccionado en las comboboxes
            if ((comboBox1.SelectedIndex<0)||(comboBox2.SelectedIndex<0)){

                MessageBox.Show("ERROR: indique los equipos del partido a analizar");

            }else{

                // obtenemos los Ids de los dos equipos entrados para pasrselos a la funcion
                id_eq_local = Analizador.ConsultaIdEquipo(ListaEquiposEquipo[comboBox1.SelectedIndex]);
                id_eq_visitante = Analizador.ConsultaIdEquipo(ListaEquiposEquipo[comboBox2.SelectedIndex]);

                // miramos si los equipos seleccionados existen y si el local y el visitante son diferentes
                if ((id_eq_local == 0) || (id_eq_visitante == 0) || (id_eq_visitante == id_eq_local)){

                    MessageBox.Show("ERROR: alguno de los equipos entrados es incorrecto o coinciden");

                }else{

                    // inicializamos la View List con los campos pertinentes
                    listView1.Clear();
                    listView1.View = View.Details;// para que se vean los detalles nombre de columna etc

                    listView1.Columns.Add("N", 35, HorizontalAlignment.Center);
                    listView1.Columns.Add("Temporada", 75, HorizontalAlignment.Center);
                    listView1.Columns.Add("N Jor.", 50, HorizontalAlignment.Center);
                    listView1.Columns.Add("Divisin", 60, HorizontalAlignment.Center);
                    listView1.Columns.Add("Fecha", 75, HorizontalAlignment.Center);
                    listView1.Columns.Add("Local", 75, HorizontalAlignment.Center);
                    listView1.Columns.Add("Goles", 50, HorizontalAlignment.Center);
                    listView1.Columns.Add("Visitante", 75, HorizontalAlignment.Center);
                    listView1.Columns.Add("Goles", 50, HorizontalAlignment.Center);
                    listView1.Columns.Add("1 X 2", 45, HorizontalAlignment.Center);
                    listView1.Columns.Add("Victoria", 60, HorizontalAlignment.Center);

                    // inicializamos la View List2 con los campos pertinentes
                    listView2.Clear();
                    listView2.View = View.Details;// para que se vean los detalles nombre de columna etc
                    listView2.Columns.Add("Equipo", 90, HorizontalAlignment.Center);
                    listView2.Columns.Add("G. marcados", 80, HorizontalAlignment.Center);
                    listView2.Columns.Add("G. marc. / partido", 105, HorizontalAlignment.Center);
                    listView2.Columns.Add("G. encajados", 85, HorizontalAlignment.Center);
                    listView2.Columns.Add("G. encaj. / partido", 110, HorizontalAlignment.Center);
                    listView2.Columns.Add("Victorias", 60, HorizontalAlignment.Center);
                    listView2.Columns.Add("P. victoria", 80, HorizontalAlignment.Center);
                    listView2.Columns.Add("Empates", 65, HorizontalAlignment.Center);
                    listView2.Columns.Add("P. empate", 80, HorizontalAlignment.Center);
                    listView2.Columns.Add("Derrotas", 60, HorizontalAlignment.Center);
                    listView2.Columns.Add("P. derrota", 80, HorizontalAlignment.Center);
                    listView2.Columns.Add("P. analizados", 90, HorizontalAlignment.Center);

                    // printamos el mensaje de inicio de analisis
                    if (radioButton1.Checked==true){
                        textBox1.Text = textBox1.Text + "Iniciada bsqeda de enfrentamientos con factor campo entre " + comboBox1.Text + " (local) y " + comboBox2.Text + " (visitante) entre las temporadas " + comboBox3.Text + " y " + comboBox3.Text + "\r\n";
                    }else{
                        textBox1.Text = textBox1.Text + "Iniciada la bsqeda de enfrentamientos entre " + comboBox1.Text + " y " + comboBox2.Text + " entre las temporadas " + comboBox3.Text + " y " + comboBox3.Text + "\r\n";
                    }//if

                    int_aux2 = 0;
                    // en funcion de si se han seleccionado los valores de 1a, los de 2a o los de 1a y segunda, hacemos una llamada u otra
                    if (radioButton3.Checked==true){
                        int_aux2 = Analizador.ConsultaPartidosEquiposRangoTemporadas(Lista_Temporadas_Id[comboBox3.SelectedIndex], Lista_Temporadas_Id[comboBox4.SelectedIndex], id_eq_local, id_eq_visitante, Analizador.tipo_division.Primera, Lista_temporada, Lista_fecha, Lista_jornada, Lista_ids_eq_local, Lista_ids_eq_visitante, Lista_goles_eq_local, Lista_goles_eq_visitante, Lista_division_encuentro);
                    }else if (radioButton4.Checked==true){
                        int_aux2 = Analizador.ConsultaPartidosEquiposRangoTemporadas(Lista_Temporadas_Id[comboBox3.SelectedIndex], Lista_Temporadas_Id[comboBox4.SelectedIndex], id_eq_local, id_eq_visitante, Analizador.tipo_division.Segunda, Lista_temporada, Lista_fecha, Lista_jornada, Lista_ids_eq_local, Lista_ids_eq_visitante, Lista_goles_eq_local, Lista_goles_eq_visitante, Lista_division_encuentro);
                    }else if (radioButton5.Checked==true){
                        int_aux2 = Analizador.ConsultaPartidosEquiposRangoTemporadas(Lista_Temporadas_Id[comboBox3.SelectedIndex], Lista_Temporadas_Id[comboBox4.SelectedIndex], id_eq_local, id_eq_visitante, Analizador.tipo_division.PrimeraSegunda, Lista_temporada, Lista_fecha, Lista_jornada, Lista_ids_eq_local, Lista_ids_eq_visitante, Lista_goles_eq_local, Lista_goles_eq_visitante, Lista_division_encuentro);
                    }//if
                   
                    // miramos si la consulta ha retornado resultdos
                    if (int_aux2 <= 0){

                        textBox1.Text = textBox1.Text + "No se han localizado enfrentamientos entre ambos equipos!\r\n";

                    }else{
                       
                        // inicializacion de las variables utiliadas para los diferetes calculos
                        local_goles_marcados = 0;
                        visitante_goles_marcados = 0;
                        local_goles_encajados = 0;
                        visitante_goles_encajados = 0;
                        partidos_analizados = 0;
                        local_victorias = 0;
                        local_empates = 0;
                        local_derrotas = 0;
                        visitante_victorias = 0;
                        visitante_empates = 0;
                        visitante_derrotas = 0;

                        // procesamos cada uno de los partidos retornados tras la consulta
                        int_aux1=0;
                        while (int_aux1 < int_aux2)
                        {
                            
                            // antes de insertar en la lista miramos si se encuentra activado el checkox mediante el que se
                            // especifica si se tiene en cuenta el factor equipo Local / Visitante o no    
                            if ( radioButton1.Checked==true){
                                
                                // se ha de tener en cuenta el factor campo, por lo que solo tomaremos aquellos partidos en que
                                // el equipo del ComboBox Local juegue como Local y el del ComboBox Visitante juegue como Visitante.
                                if (id_eq_local == Lista_ids_eq_local[int_aux1])
                                {

                                    lvitem_aux = new ListViewItem((listView1.Items.Count + 1).ToString());

                                    //Insertamos la temporada
                                    lvitem_aux.SubItems.Add(Lista_temporada[int_aux1]);

                                    //Insertamos el numero de jornada
                                    lvitem_aux.SubItems.Add(Lista_jornada[int_aux1].ToString());

                                    //Insertamos la division a la que pertenece el encuentro
                                    lvitem_aux.SubItems.Add(Lista_division_encuentro[int_aux1].ToString());

                                    //Insertamos la fecha
                                    lvitem_aux.SubItems.Add(Lista_fecha[int_aux1]);

                                    //Insertamos el eq local
                                    equipo_local_partido=comboBox1.Text;
                                    lvitem_aux.SubItems.Add(equipo_local_partido);

                                    //Insertamos goles del eq local
                                    lvitem_aux.SubItems.Add(Lista_goles_eq_local[int_aux1].ToString());
                                    local_goles_marcados = local_goles_marcados + Lista_goles_eq_local[int_aux1];
                                    visitante_goles_encajados = visitante_goles_encajados + Lista_goles_eq_local[int_aux1];

                                    //Insertamos el eq visitante
                                    equipo_visitante_partido=comboBox2.Text;
                                    lvitem_aux.SubItems.Add(equipo_visitante_partido);                                    

                                    //Insertamos goles del eq visitante
                                    lvitem_aux.SubItems.Add(Lista_goles_eq_visitante[int_aux1].ToString());
                                    visitante_goles_marcados = visitante_goles_marcados + Lista_goles_eq_visitante[int_aux1];
                                    local_goles_encajados = local_goles_encajados + Lista_goles_eq_visitante[int_aux1];

                                    //Insertamos el resultado 1 X 2
                                    if (Lista_goles_eq_local[int_aux1]>Lista_goles_eq_visitante[int_aux1]){
                                        // 1
                                        lvitem_aux.SubItems.Add("1");
                                        local_victorias++;
                                        visitante_derrotas++;
                                        equipo_victoria = equipo_local_partido ;                                                                                
                                    }else if (Lista_goles_eq_local[int_aux1]<Lista_goles_eq_visitante[int_aux1]){                                                                                
                                        // 2
                                        lvitem_aux.SubItems.Add("2");
                                        local_derrotas++;
                                        visitante_victorias++;
                                        equipo_victoria = equipo_visitante_partido;
                                    }else{
                                        // X
                                        lvitem_aux.SubItems.Add("X");
                                        local_empates++;
                                        visitante_empates++;
                                        equipo_victoria = "empate";
                                    }//if

                                    //Se inserta el equipo que ha ganado
                                    lvitem_aux.SubItems.Add(equipo_victoria);

                                    //Se inserta en la lista
                                    listView1.Items.Add(lvitem_aux);

                                    // incrementamos el contador de partidos analizados
                                    partidos_analizados++;
                                
                                }//if
                              
                            }else{
                               
                                // no se ha de tener en cuenta el factor campo por lo que insertamos todos los partidos independientemente 
                                // de si el equipo del Combo Local juega como Local o el del Combo Visitante juegua como Visitante
                                lvitem_aux = new ListViewItem((listView1.Items.Count + 1).ToString());

                                //Insertamos la temporada
                                lvitem_aux.SubItems.Add(Lista_temporada[int_aux1]);

                                //Insertamos el numero de jornada
                                lvitem_aux.SubItems.Add(Lista_jornada[int_aux1].ToString());

                                //Insertamos la division a la que pertenece el encuentro
                                lvitem_aux.SubItems.Add(Lista_division_encuentro[int_aux1].ToString());
                                
                                //Insertamos la fecha
                                lvitem_aux.SubItems.Add(Lista_fecha[int_aux1]);

                                //Insertamos el nombre del eq local, no confundir con el local de la combobox ( lo tomamos de la combobox )
                                if (id_eq_local == Lista_ids_eq_local[int_aux1]){
                                    // el local del partido coincide con el local de las comboboxes
                                    equipo_local_partido = comboBox1.Text;
                                    lvitem_aux.SubItems.Add(equipo_local_partido);
                                    local_goles_marcados = local_goles_marcados + Lista_goles_eq_local[int_aux1];
                                    visitante_goles_encajados = visitante_goles_encajados + Lista_goles_eq_local[int_aux1];
                                }else{
                                    // el local del partido es el visitante de las comboboxes
                                    equipo_local_partido = comboBox2.Text;
                                    lvitem_aux.SubItems.Add(equipo_local_partido);
                                    visitante_goles_marcados = visitante_goles_marcados + Lista_goles_eq_local[int_aux1];
                                    local_goles_encajados = local_goles_encajados + Lista_goles_eq_local[int_aux1];
                                }//if

                                //Insertamos goles del eq local, no confundir con el local de la combobox 
                                lvitem_aux.SubItems.Add(Lista_goles_eq_local[int_aux1].ToString());

                                //Insertamos el nombre del eq visitante, no confundir con el visitante de la combobox ( lo tomamos de la combobox )                            
                                if (id_eq_visitante == Lista_ids_eq_visitante[int_aux1]){
                                    // el visitante del partido coincide con el visitante de las comboboxes
                                    equipo_visitante_partido = comboBox2.Text;
                                    lvitem_aux.SubItems.Add(equipo_visitante_partido);
                                    visitante_goles_marcados = visitante_goles_marcados + Lista_goles_eq_visitante[int_aux1];
                                    local_goles_encajados = local_goles_encajados + Lista_goles_eq_visitante[int_aux1];
                                }else{
                                    // el visitante del partido coincide con el local de las comboboxes
                                    equipo_visitante_partido = comboBox1.Text;
                                    lvitem_aux.SubItems.Add(equipo_visitante_partido);
                                    local_goles_marcados = local_goles_marcados + Lista_goles_eq_visitante[int_aux1];
                                    visitante_goles_encajados = visitante_goles_encajados + Lista_goles_eq_visitante[int_aux1];
                                }//if

                                //Insertamos goles del eq visitante, no confundir con el visitante de la combobox 
                                lvitem_aux.SubItems.Add(Lista_goles_eq_visitante[int_aux1].ToString());

                                //Insertamos el resultado 1 X 2
                                if (Lista_goles_eq_local[int_aux1] > Lista_goles_eq_visitante[int_aux1]){
                                    
                                    // 1
                                    lvitem_aux.SubItems.Add("1");
                                    equipo_victoria = equipo_local_partido;
                                
                                    if (id_eq_local == Lista_ids_eq_local[int_aux1]){
                                        // si el local de la lista es el local de la ComboBox, la victoria se suma al local
                                        local_victorias++;
                                        visitante_derrotas++;
                                    }else{
                                        // si el local de la lista es el visitante de la ComboBox, la victoria se suam al visitante
                                        visitante_victorias++;
                                        local_derrotas++;
                                    }//if
                                
                                }else if (Lista_goles_eq_local[int_aux1] < Lista_goles_eq_visitante[int_aux1]){

                                    equipo_victoria = equipo_visitante_partido;

                                    // 2
                                    lvitem_aux.SubItems.Add("2");

                                    if (id_eq_local == Lista_ids_eq_local[int_aux1]){
                                        // si el local de la lista es el local de la ComboBox, la derrota se suma al local
                                        local_derrotas++;
                                        visitante_victorias++;
                                    }else{
                                        // si el local de la lista es el visitante de la ComboBox, la derrota se suam al visitante
                                        visitante_derrotas++;
                                        local_victorias++;
                                    }//if

                                }else{
                                    
                                    equipo_victoria = "empate";

                                    // X
                                    lvitem_aux.SubItems.Add("X");
                                    local_empates++;
                                    visitante_empates++;

                                }//if
                                
                                //Se inserta el equipo que ha ganado
                                lvitem_aux.SubItems.Add(equipo_victoria);

                                //Se inserta en la lista
                                listView1.Items.Add(lvitem_aux);

                                // incrementamos el contador de partidos analizados
                                partidos_analizados++;

                            }//if

                            int_aux1++;

                       }//while

                       // se inserta el resumen de resultados calculados del EQUIPO LOCAL

                       // Insertamos la informacin del equipo Local
                       lvitem_aux = new ListViewItem(comboBox1.Text);
                       textBox1.Text = textBox1.Text + "Resmen de resultados del " + comboBox1.Text + ":\r\n";

                       //Insertamos los goles marcados por el equipo Local de la Combobox
                       lvitem_aux.SubItems.Add(local_goles_marcados.ToString());
                       textBox1.Text = textBox1.Text + "Goles marcados: " + local_goles_marcados.ToString() + "\r\n";

                       //Insertamos los goles marcados / partido el equipo Local de la Combobox
                       float_aux = ((float)local_goles_marcados / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "Goles marcados / partido:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos los goles encajados por el equipo Local de la Combobox
                       lvitem_aux.SubItems.Add(local_goles_encajados.ToString());
                       textBox1.Text = textBox1.Text + "Goles encajados: " + local_goles_encajados.ToString() + "\r\n";

                       //Insertamos los goles encajados / partido el equipo Local de la Combobox
                       float_aux = ((float)local_goles_encajados / (float) partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "Goles encajados / partido:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de victorias
                       lvitem_aux.SubItems.Add(local_victorias.ToString());
                       textBox1.Text = textBox1.Text + "Numero victorias:" + local_victorias.ToString() + "\r\n";

                       //Insertamos el numero de victorias / partido
                       float_aux = ((float)local_victorias / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. victoria:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de empates
                       lvitem_aux.SubItems.Add(local_empates.ToString());
                       textBox1.Text = textBox1.Text + "Numero empates:" + local_empates.ToString() + "\r\n";

                       //Insertamos el numero de empates / partido
                       float_aux = ((float)local_empates / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. empate:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de derrotas
                       lvitem_aux.SubItems.Add(local_derrotas.ToString());
                       textBox1.Text = textBox1.Text + "Numero derrotas:" + local_derrotas.ToString() + "\r\n";

                       //Insertamos el numero de derrotas
                       float_aux = ((float)local_derrotas / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. derrota:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el total de partidos analizados
                       lvitem_aux.SubItems.Add(partidos_analizados.ToString());
                       textBox1.Text = textBox1.Text + "Partidos analizados:" + partidos_analizados.ToString() + "\r\n";

                       //Se inserta en la lista
                       listView2.Items.Add(lvitem_aux);

                       // se inserta el resumen de resultados calculados del EQUIPO VISITANTE

                       // Insertamos la informacin del equipo Local
                       lvitem_aux = new ListViewItem(comboBox2.Text);
                       textBox1.Text = textBox1.Text + "Resmen de resultados del " + comboBox2.Text + ":\r\n";

                       //Insertamos los goles marcados por el equipo visitante de la Combobox
                       lvitem_aux.SubItems.Add(visitante_goles_marcados.ToString());
                       textBox1.Text = textBox1.Text + "Goles marcados: " + visitante_goles_marcados.ToString() + "\r\n";

                       //Insertamos los goles marcados / partido el equipo visitante de la Combobox
                       float_aux = ((float)visitante_goles_marcados / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "Goles marcados / partido:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos los goles encajados por el equipo visitante de la Combobox
                       lvitem_aux.SubItems.Add(visitante_goles_encajados.ToString());
                       textBox1.Text = textBox1.Text + "Goles encajados:" + local_goles_encajados.ToString() + "\r\n";

                       //Insertamos los goles encajados / partido del equipo visitante de la Combobox
                       float_aux = ((float)visitante_goles_encajados / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "Goles encajados / partido:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de victorias
                       lvitem_aux.SubItems.Add(visitante_victorias.ToString());
                       textBox1.Text = textBox1.Text + "Numero victorias:" + visitante_victorias.ToString() + "\r\n";

                       //Insertamos el numero de victorias / partido
                       float_aux = ((float)visitante_victorias / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. victoria:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de empates
                       lvitem_aux.SubItems.Add(visitante_empates.ToString());
                       textBox1.Text = textBox1.Text + "Numero empates:" + visitante_empates.ToString() + "\r\n";

                       //Insertamos el numero de empates / partido
                       float_aux = ((float)local_empates / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. empate:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el numero de derrotas
                       lvitem_aux.SubItems.Add(visitante_derrotas.ToString());
                       textBox1.Text = textBox1.Text + "Numero derrotas:" + visitante_derrotas.ToString() + "\r\n";

                       //Insertamos el numero de derrotas
                       float_aux = ((float)visitante_derrotas / (float)partidos_analizados);
                       lvitem_aux.SubItems.Add(String.Format("{0:0.00}", float_aux));
                       textBox1.Text = textBox1.Text + "P. partido:" + String.Format("{0:0.00}", float_aux) + "\r\n";

                       //Insertamos el total de partidos analizados
                       lvitem_aux.SubItems.Add(partidos_analizados.ToString());

                       //Se inserta en la lista
                       listView2.Items.Add(lvitem_aux);
                       textBox1.Text = textBox1.Text + "Partidos analizados:" + partidos_analizados.ToString() + "\r\n";

                       // se printa el texto indicando el final de la bsqueda
                       textBox1.Text = textBox1.Text + "Finalizada la bsqeda de enfrentamientos\r\n";

                   }//if (int_aux2 <= 0){

                }//if ( (id_eq_local==0) || (id_eq_visitante==0)){                

            }// if ((comboBox1.SelectedIndex!=0)
            

        }//button2_Click


        private void Form4_FormClosing(object sender, FormClosingEventArgs e)
        {
            LFSuite.Form1 FormPadre = (LFSuite.Form1)this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_prediccion_partido = null;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // al hacer el close ya se llamara al evento closing del formulario
            this.Close();

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
        
        }

        private void listView1_ColumnClick(object sender, ColumnClickEventArgs e)
        {

            if (e.Column == lvwColumnSorter.SortColumn)
            {
                if (lvwColumnSorter.Order == SortOrder.Ascending)
                {
                    // Revers tge cyrrebt sort direction for this column
                    lvwColumnSorter.Order = SortOrder.Descending;
                }
                else
                {
                    lvwColumnSorter.Order = SortOrder.Ascending;
                }//if

            }
            else
            {

                // Set the column number that is to be sorted; default to ascending
                lvwColumnSorter.SortColumn = e.Column;
                lvwColumnSorter.Order = SortOrder.Ascending;

            }//if

            // Perform teh sort with these new sort options
            this.listView1.Sort();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            int i_aux;

            // miramos que color hemos de asignar a cada uno de los resultados contenidos en la ListView
            for (i_aux = 0; i_aux < listView1.Items.Count; i_aux++){

                if (listView1.Items[(int)i_aux].SubItems[10].Text == comboBox1.Text){

                    // si el equipo de la victoria  es el seleccionado en la ComboBox "Local" pintamos la fila de un color
                    listView1.Items[(int)i_aux].BackColor = Color.DarkTurquoise;

                }else if (listView1.Items[(int)i_aux].SubItems[10].Text == comboBox2.Text){
                    
                    // si el equipo de la victoria es el seleccionado en la ComboBox "Visitante" pintamos la fila de otro color
                    listView1.Items[(int)i_aux].BackColor = Color.Orange;

                }else{

                    // si hay empate no coloreamos la la fila

                }//if
            
            }//for
        }
    }

    // <summary>
    /// This class is an implementation of the 'IComparer' interface.
    /// </summary>
    public class ListViewColumnSorter_Form4 : IComparer
    {

        /// <summary>
        /// Specifies the column to be sorted
        /// </summary>
        private int ColumnToSort;
        /// <summary>
        /// Specifies the order in which to sort (i.e. 'Ascending').
        /// </summary>
        private SortOrder OrderOfSort;
        /// <summary>
        /// Case insensitive comparer object
        /// </summary>
        private CaseInsensitiveComparer ObjectCompare;

        /// <summary>
        /// Class constructor.  Initializes various elements
        /// </summary>
        public ListViewColumnSorter_Form4()
        {
            // Initialize the column to '0'
            ColumnToSort = 0;

            // Initialize the sort order to 'none'
            OrderOfSort = SortOrder.None;

            // Initialize the CaseInsensitiveComparer object
            ObjectCompare = new CaseInsensitiveComparer();
        }

        /// <summary>
        /// This method is inherited from the IComparer interface.  It compares the two objects passed using a case insensitive comparison.
        /// </summary>
        /// <param name="x">First object to be compared</param>
        /// <param name="y">Second object to be compared</param>
        /// <returns>The result of the comparison. "0" if equal, negative if 'x' is less than 'y' and positive if 'x' is greater than 'y'</returns>
        public int Compare(object x, object y)
        {

            int compareResult;
            ListViewItem listviewX, listviewY;


            // Cast the objects to be compared to ListViewItem objects
            listviewX = (ListViewItem)x;
            listviewY = (ListViewItem)y;

            // apao que he puesto para que las variable se conviertan al tipo de dato adecuado ya que sino los numero 
            // se tratam como texto y se ordenan incorrectamente, de hecho siempre se comparan numeros, menos cuando han seleccionado la columna del nombre
            if ((ColumnToSort == 1) || (ColumnToSort == 4) || (ColumnToSort == 5) || (ColumnToSort == 7) || (ColumnToSort == 9) || (ColumnToSort == 10))
            {
                compareResult = ObjectCompare.Compare(Convert.ToString(listviewX.SubItems[ColumnToSort].Text), Convert.ToString(listviewY.SubItems[ColumnToSort].Text));
            }
            else
            {
                compareResult = ObjectCompare.Compare(Convert.ToDouble(listviewX.SubItems[ColumnToSort].Text), Convert.ToDouble(listviewY.SubItems[ColumnToSort].Text));
            }


            // Calculate correct return value based on object comparison
            if (OrderOfSort == SortOrder.Ascending)
            {
                // Ascending sort is selected, return normal result of compare operation
                return compareResult;
            }
            else if (OrderOfSort == SortOrder.Descending)
            {
                // Descending sort is selected, return negative result of compare operation
                return (-compareResult);
            }
            else
            {
                // Return '0' to indicate they are equal
                return 0;
            }
 
        }

        /// <summary>
        /// Gets or sets the number of the column to which to apply the sorting operation (Defaults to '0').
        /// </summary>
        public int SortColumn
        {
            set
            {
                ColumnToSort = value;
            }
            get
            {
                return ColumnToSort;
            }
        }

        /// <summary>
        /// Gets or sets the order of sorting to apply (for example, 'Ascending' or 'Descending').
        /// </summary>
        public SortOrder Order
        {
            set
            {
                OrderOfSort = value;
            }
            get
            {
                return OrderOfSort;
            }
        }

    }// ListViewColumnSorter_Form4

}