using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    public partial class Form5 : Form
    {
        private ListViewColumnSorter_Form5 lvwColumnSorter;// para poder ordenar la ViewList
        List<string> Lista_Temporadas_Anio1_Anio2  = new List<string>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los nombres de todas las temporadas
        List<int> Lista_Temporadas_Id = new List<int>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los IDs de todas las temporadas            

        public Form5()
        {
            InitializeComponent();
            // aadido para permitir la ordenacion de las columnas
            lvwColumnSorter = new ListViewColumnSorter_Form5();
            this.listView1.ListViewItemSorter = lvwColumnSorter;
            this.listView2.ListViewItemSorter = lvwColumnSorter;
        }

        // procedimiento que rellena las ViewLists del formulario de equipos con la informacion de la BBDD
        private void ActualizaValoresViewList()
        {

            int id_equipo;
            int total_equipos;
            int int_aux;
            // variables para 1a division            
            int n_partidos_1a = 0;
            int puntos_1a = 0;
            float p_p_partido_1a = 0;
            int vic_casa_1a = 0;
            int vic_f_casa_1a = 0;
            int derr_casa_1a = 0;
            int derr_f_casa_1a = 0;
            int emp_casa_1a = 0;
            int emp_f_casa_1a = 0;
            int gol_marc_casa_1a = 0;
            int gol_marc_f_casa_1a = 0;
            int gol_encaj_casa_1a = 0;
            int gol_encaj_f_casa_1a = 0;
            // variables para 2a division
            int n_partidos_2a = 0;
            int puntos_2a = 0;
            float p_p_partido_2a = 0;
            int vic_casa_2a = 0;
            int vic_f_casa_2a = 0;
            int derr_casa_2a = 0;
            int derr_f_casa_2a = 0;
            int emp_casa_2a = 0;
            int emp_f_casa_2a = 0;
            int gol_marc_casa_2a = 0;
            int gol_marc_f_casa_2a = 0;
            int gol_encaj_casa_2a = 0;
            int gol_encaj_f_casa_2a = 0;
            // listas utilizadas para recibir de ConsultaEquipos la lista de todos los equipos de la BBDD
            List<int> Lista_Equipos_Id = new List<int>();
            List<string> Lista_Equipos_Equipo = new List<string>();

            ListViewItem lvitem_aux;

            // inicializamos la View List de los equipos de 1a division
            listView1.Clear();
            listView1.View = View.Details;// para que se vean los detalles nombre de columna etc
            listView1.Columns.Add("#", 25, HorizontalAlignment.Center);
            listView1.Columns.Add("Equipo", 125, HorizontalAlignment.Center);
            listView1.Columns.Add("Puntos", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("N Part.", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("PpPart.", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Victorias", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Vict. en casa", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("Vict. f. casa", 80, HorizontalAlignment.Center);
            listView1.Columns.Add("Derrotas", 55, HorizontalAlignment.Center);
            listView1.Columns.Add("Dtas. en casa", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("Dtas. f. casa", 75, HorizontalAlignment.Center);
            listView1.Columns.Add("Empates", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("Emp. en casa", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("Emp. f. casa", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles marc.", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("G. marc. en casa", 100, HorizontalAlignment.Center);
            listView1.Columns.Add("G. marc. f. casa", 100, HorizontalAlignment.Center);
            listView1.Columns.Add("Goles encaj.", 85, HorizontalAlignment.Center);
            listView1.Columns.Add("G. encaj. en casa", 100, HorizontalAlignment.Center);
            listView1.Columns.Add("G. encaj. f. casa", 100, HorizontalAlignment.Center);
            listView1.Columns.Add("I.Calidad 1", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("I.Calidad 2", 65, HorizontalAlignment.Center);

            // inicializamos la View List de los equipos de 2a division
            listView2.Clear();
            listView2.View = View.Details;// para que se vean los detalles nombre de columna etc
            listView2.Columns.Add("#", 25, HorizontalAlignment.Center);
            listView2.Columns.Add("Equipo", 125, HorizontalAlignment.Center);
            listView2.Columns.Add("Puntos", 55, HorizontalAlignment.Center);
            listView2.Columns.Add("N Part.", 55, HorizontalAlignment.Center);
            listView2.Columns.Add("PpPart.", 55, HorizontalAlignment.Center);
            listView2.Columns.Add("Victorias", 55, HorizontalAlignment.Center);
            listView2.Columns.Add("Vict. en casa", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("Vict. f. casa", 80, HorizontalAlignment.Center);
            listView2.Columns.Add("Derrotas", 55, HorizontalAlignment.Center);
            listView2.Columns.Add("Dtas. en casa", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("Dtas. f. casa", 75, HorizontalAlignment.Center);
            listView2.Columns.Add("Empates", 65, HorizontalAlignment.Center);
            listView2.Columns.Add("Emp. en casa", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("Emp. f. casa", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("Goles marc.", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("G. marc. en casa", 100, HorizontalAlignment.Center);
            listView2.Columns.Add("G. marc. f. casa", 100, HorizontalAlignment.Center);
            listView2.Columns.Add("Goles encaj.", 85, HorizontalAlignment.Center);
            listView2.Columns.Add("G. encaj. en casa", 100, HorizontalAlignment.Center);
            listView2.Columns.Add("G. encaj. f. casa", 100, HorizontalAlignment.Center);
            listView2.Columns.Add("I.Calidad 1", 65, HorizontalAlignment.Center);
            listView2.Columns.Add("I.Calidad 2", 65, HorizontalAlignment.Center);

            // mostramos el contenido de la tabla en las ViewLists del formulario
            total_equipos = Analizador.ConsultaEquipos(Lista_Equipos_Id, Lista_Equipos_Equipo);
            for (int_aux = 0; int_aux < total_equipos; int_aux++)
            {
                id_equipo = Lista_Equipos_Id[int_aux];
                Analizador.ConsultaVariablesEquipo(id_equipo, ref vic_casa_1a, ref vic_f_casa_1a, ref  derr_casa_1a, ref  derr_f_casa_1a, ref  emp_casa_1a, ref emp_f_casa_1a, ref gol_marc_casa_1a, ref gol_marc_f_casa_1a, ref  gol_encaj_casa_1a, ref gol_encaj_f_casa_1a, ref vic_casa_2a, ref vic_f_casa_2a, ref derr_casa_2a, ref derr_f_casa_2a, ref emp_casa_2a, ref emp_f_casa_2a, ref gol_marc_casa_2a, ref gol_marc_f_casa_2a, ref gol_encaj_casa_2a, ref  gol_encaj_f_casa_2a);
                
                //#
                lvitem_aux = new ListViewItem(id_equipo.ToString());
                //Equipo
                lvitem_aux.SubItems.Add(Lista_Equipos_Equipo[int_aux]);
                //Puntos

                puntos_1a = Analizador.PUNTOS_VICTORIA * (vic_casa_1a + vic_f_casa_1a) + Analizador.PUNTOS_EMPATE * (emp_casa_1a + emp_f_casa_1a) + Analizador.PUNTOS_DERROTA * (derr_casa_1a + derr_f_casa_1a);
                lvitem_aux.SubItems.Add(puntos_1a.ToString());
                //N Part
                n_partidos_1a = vic_casa_1a + vic_f_casa_1a + derr_casa_1a + derr_f_casa_1a + emp_casa_1a + emp_f_casa_1a;
                lvitem_aux.SubItems.Add(n_partidos_1a.ToString());                
                //P/Partido
                if (n_partidos_1a != 0) p_p_partido_1a = (float)puntos_1a / (float)n_partidos_1a; else p_p_partido_1a = 0;
                lvitem_aux.SubItems.Add(p_p_partido_1a.ToString());                
                //Victorias
                lvitem_aux.SubItems.Add((vic_casa_1a + vic_f_casa_1a).ToString());
                //Vict. en casa
                lvitem_aux.SubItems.Add(vic_casa_1a.ToString());
                //Vict. f. casa
                lvitem_aux.SubItems.Add(vic_f_casa_1a.ToString());
                //Derrotas
                lvitem_aux.SubItems.Add((derr_casa_1a + derr_f_casa_1a).ToString());
                //Dtas. en casa
                lvitem_aux.SubItems.Add(derr_casa_1a.ToString());
                //Dtas. f. casa
                lvitem_aux.SubItems.Add(derr_f_casa_1a.ToString());
                //Empates
                lvitem_aux.SubItems.Add((emp_casa_1a + emp_f_casa_1a).ToString());
                //Emp. en casa
                lvitem_aux.SubItems.Add(emp_casa_1a.ToString());
                //Emp. f. casa
                lvitem_aux.SubItems.Add(emp_f_casa_1a.ToString());
                //Goles marc
                lvitem_aux.SubItems.Add((gol_marc_casa_1a + gol_marc_f_casa_1a).ToString());
                //G. marc. en casa
                lvitem_aux.SubItems.Add(gol_marc_casa_1a.ToString());
                //G. marc. f. casa
                lvitem_aux.SubItems.Add(gol_marc_f_casa_1a.ToString());
                //Goles encaj.
                lvitem_aux.SubItems.Add((gol_encaj_casa_1a + gol_encaj_f_casa_1a).ToString());
                //G. encaj. en casa
                lvitem_aux.SubItems.Add(gol_encaj_casa_1a.ToString());
                //G. encaj. f. casa
                lvitem_aux.SubItems.Add(gol_encaj_f_casa_1a.ToString());
                //I.Calidad 1
                lvitem_aux.SubItems.Add("-");
                //I.Calidad 1
                lvitem_aux.SubItems.Add("-");

                //Se inserta en la lista
                listView1.Items.Add(lvitem_aux);
                
                //#
                lvitem_aux = new ListViewItem(id_equipo.ToString());
                //Equipo
                lvitem_aux.SubItems.Add(Lista_Equipos_Equipo[int_aux]);
                //Puntos
                puntos_2a = Analizador.PUNTOS_VICTORIA * (vic_casa_2a + vic_f_casa_2a) + Analizador.PUNTOS_EMPATE * (emp_casa_2a + emp_f_casa_2a) + Analizador.PUNTOS_DERROTA * (derr_casa_2a + derr_f_casa_2a);
                lvitem_aux.SubItems.Add(puntos_2a.ToString());
                //N Part
                n_partidos_2a = vic_casa_2a + vic_f_casa_2a + derr_casa_2a + derr_f_casa_2a + emp_casa_2a + emp_f_casa_2a;
                lvitem_aux.SubItems.Add(n_partidos_2a.ToString());
                //P/Partido
                if (n_partidos_2a != 0) p_p_partido_2a = (float)puntos_2a / (float)n_partidos_2a; else p_p_partido_2a = 0;
                lvitem_aux.SubItems.Add(p_p_partido_2a.ToString());                
                //Victorias
                lvitem_aux.SubItems.Add((vic_casa_2a + vic_f_casa_2a).ToString());
                //Vict. en casa
                lvitem_aux.SubItems.Add(vic_casa_2a.ToString());
                //Vict. f. casa
                lvitem_aux.SubItems.Add(vic_f_casa_2a.ToString());
                //Derrotas
                lvitem_aux.SubItems.Add((derr_casa_2a + derr_f_casa_2a).ToString());
                //Dtas. en casa
                lvitem_aux.SubItems.Add(derr_casa_2a.ToString());
                //Dtas. f. casa
                lvitem_aux.SubItems.Add(derr_f_casa_2a.ToString());
                //Empates
                lvitem_aux.SubItems.Add((emp_casa_2a + emp_f_casa_2a).ToString());
                //Emp. en casa
                lvitem_aux.SubItems.Add(emp_casa_2a.ToString());
                //Emp. f. casa
                lvitem_aux.SubItems.Add(emp_f_casa_2a.ToString());
                //Goles marc
                lvitem_aux.SubItems.Add((gol_marc_casa_2a + gol_marc_f_casa_2a).ToString());
                //G. marc. en casa
                lvitem_aux.SubItems.Add(gol_marc_casa_2a.ToString());
                //G. marc. f. casa
                lvitem_aux.SubItems.Add(gol_marc_f_casa_2a.ToString());
                //Goles encaj.
                lvitem_aux.SubItems.Add((gol_encaj_casa_2a + gol_encaj_f_casa_2a).ToString());
                //G. encaj. en casa
                lvitem_aux.SubItems.Add(gol_encaj_casa_2a.ToString());
                //G. encaj. f. casa
                lvitem_aux.SubItems.Add(gol_encaj_f_casa_2a.ToString());
                //I.Calidad 1
                lvitem_aux.SubItems.Add("-");
                //I.Calidad 1
                lvitem_aux.SubItems.Add("-");

                //Se inserta en la lista
                listView2.Items.Add(lvitem_aux);

            }//for

        }//ActualizaValoresViewList


        private void Form5_Load(object sender, EventArgs e)
        {
            int total_temporadas;
            int int_aux;

            // actualiza la etiqueta de puntuacion
            label5.Text = "Puntuacin: Victoria " + Analizador.PUNTOS_VICTORIA.ToString() + " - Empate " + Analizador.PUNTOS_EMPATE.ToString() + " - Derrota " + Analizador.PUNTOS_DERROTA.ToString();

            // se llena la tabla con los valores de la BBDD
            ActualizaValoresViewList();

            // se llenan las ComboBoxes con todas las temporadas disponibles 
            total_temporadas = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (int_aux = 0; int_aux < total_temporadas; int_aux++){
                comboBox1.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);
                comboBox2.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);           
            }//for
            // inicializamos con la primera y ulima temporada
            comboBox1.Text = Lista_Temporadas_Anio1_Anio2[total_temporadas-1].ToString();
            comboBox2.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();    
            

        }


        private void button2_Click(object sender, EventArgs e)
        {
            
            // llamamos al procedimiento que actualiza las variables de cada equipo en la BBDD
            if (Analizador.ActualizaVariablesEquipos(Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]) == true)
            {
                ActualizaValoresViewList();
                MessageBox.Show("Las variables de los equipos se han recalculado correctamente");
            }
            else
            {
                MessageBox.Show("ERROR: Se ha producido algun error al recalcular las variables de los equipos");
            }//if
        }

        private void button3_Click(object sender, EventArgs e)
        {

        }

        private void listView1_ColumnClick(object sender, ColumnClickEventArgs e)
        {

            if (e.Column == lvwColumnSorter.SortColumn)
            {
                if (lvwColumnSorter.Order == SortOrder.Ascending)
                {
                    // Revers tge cyrrebt sort direction for this column
                    lvwColumnSorter.Order = SortOrder.Descending;
                }
                else
                {
                    lvwColumnSorter.Order = SortOrder.Ascending;
                }//if

            }
            else
            {

                // Set the column number that is to be sorted; default to ascending
                lvwColumnSorter.SortColumn = e.Column;
                lvwColumnSorter.Order = SortOrder.Ascending;

            }//if

            // Perform teh sort with these new sort options
            this.listView1.Sort();

        }

        private void listView2_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            if (e.Column == lvwColumnSorter.SortColumn)
            {
                if (lvwColumnSorter.Order == SortOrder.Ascending)
                {
                    // Revers tge cyrrebt sort direction for this column
                    lvwColumnSorter.Order = SortOrder.Descending;
                }
                else
                {
                    lvwColumnSorter.Order = SortOrder.Ascending;
                }//if

            }
            else
            {

                // Set the column number that is to be sorted; default to ascending
                lvwColumnSorter.SortColumn = e.Column;
                lvwColumnSorter.Order = SortOrder.Ascending;

            }//if

            // Perform the sort with these new sort options
            this.listView2.Sort();
        }

        private void Form5_FormClosing(object sender, FormClosingEventArgs e)
        {
            LFSuite.Form1 FormPadre = (LFSuite.Form1)this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_estadisticas_equipos = null;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // cerramos el formulario ( se llamara al evento closing que gestiona el tema del puntero en el parent etc.)
            this.Close();
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }
    
    }//class Form5 : Form


    // <summary>
    /// This class is an implementation of the 'IComparer' interface.
    /// </summary>
    public class ListViewColumnSorter_Form5 : IComparer
    {

        /// <summary>
        /// Specifies the column to be sorted
        /// </summary>
        private int ColumnToSort;
        /// <summary>
        /// Specifies the order in which to sort (i.e. 'Ascending').
        /// </summary>
        private SortOrder OrderOfSort;
        /// <summary>
        /// Case insensitive comparer object
        /// </summary>
        private CaseInsensitiveComparer ObjectCompare;

        /// <summary>
        /// Class constructor.  Initializes various elements
        /// </summary>
        public ListViewColumnSorter_Form5()
        {
            // Initialize the column to '0'
            ColumnToSort = 0;

            // Initialize the sort order to 'none'
            OrderOfSort = SortOrder.None;

            // Initialize the CaseInsensitiveComparer object
            ObjectCompare = new CaseInsensitiveComparer();
        }

        /// <summary>
        /// This method is inherited from the IComparer interface.  It compares the two objects passed using a case insensitive comparison.
        /// </summary>
        /// <param name="x">First object to be compared</param>
        /// <param name="y">Second object to be compared</param>
        /// <returns>The result of the comparison. "0" if equal, negative if 'x' is less than 'y' and positive if 'x' is greater than 'y'</returns>
        public int Compare(object x, object y)
        {

            int compareResult;
            ListViewItem listviewX, listviewY;


            // Cast the objects to be compared to ListViewItem objects
            listviewX = (ListViewItem)x;
            listviewY = (ListViewItem)y;

            // apao que he puesto para que las variable se conviertan al tipo de dato adecuado ya que sino los numero 
            // se tratam como texto y se ordenan incorrectamente, de hecho siempre se comparan numeros, menos cuando han seleccionado la columna del nombre
            if (ColumnToSort == 1)
            {
                compareResult = ObjectCompare.Compare(Convert.ToString(listviewX.SubItems[ColumnToSort].Text), Convert.ToString(listviewY.SubItems[ColumnToSort].Text));
            }
            else
            {
                compareResult = ObjectCompare.Compare(Convert.ToDouble(listviewX.SubItems[ColumnToSort].Text), Convert.ToDouble(listviewY.SubItems[ColumnToSort].Text));
            }


            // Calculate correct return value based on object comparison
            if (OrderOfSort == SortOrder.Ascending)
            {
                // Ascending sort is selected, return normal result of compare operation
                return compareResult;
            }
            else if (OrderOfSort == SortOrder.Descending)
            {
                // Descending sort is selected, return negative result of compare operation
                return (-compareResult);
            }
            else
            {
                // Return '0' to indicate they are equal
                return 0;
            }
        }

        /// <summary>
        /// Gets or sets the number of the column to which to apply the sorting operation (Defaults to '0').
        /// </summary>
        public int SortColumn
        {
            set
            {
                ColumnToSort = value;
            }
            get
            {
                return ColumnToSort;
            }
        }

        /// <summary>
        /// Gets or sets the order of sorting to apply (for example, 'Ascending' or 'Descending').
        /// </summary>
        public SortOrder Order
        {
            set
            {
                OrderOfSort = value;
            }
            get
            {
                return OrderOfSort;
            }
        }

    }// ListViewColumnSorter_Form5

}