using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{

    public partial class Form6 : Form
    {       

        public enum resultado { Uno = 1, Dos = 2, Equis = 3 };
        public enum tipo_grafico { Barras = 1, BarrasGruesas = 2, Lineas = 3 };

        informacion_grafica_signos grafica = new informacion_grafica_signos();

        // bitmap donde pintaremos los graficos, asi seran persistentes, es decir no se borraran al mover los formularios etc.
        private System.Drawing.Bitmap bitmap_con_graficos; 

        List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los nombres de todas las temporadas
        List<int> Lista_Temporadas_Id = new List<int>();// utilizada para llamar a la funcion que retorna la lista de las temporadas y guardar los IDs de todas las temporadas            
            
        /*Description:
        *   Procedimiento que dibuja la grfica de frecuencia del signo indicado
        * Recives:
        * Returns:
        */
        private void DibujaProbabilidad(int [] frecuencia,int total_jornadas, resultado signo,tipo_grafico estilo_del_grafico, Color color){
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);
            
            int int_aux;
            int origen_x;
            int origen_y;
            int alto_grafico;
            int ancho_grafico;
            int ancho_barra;
            int alto_barra;
            int x;
            int y;

            switch (signo){
                case resultado.Uno:
                    origen_x = grafica.origenx_grafico_2;
                    origen_y = grafica.origeny_grafico_2;
                    alto_grafico = grafica.alto_grafico_2;
                    ancho_grafico = grafica.ancho_grafico_2;
                    break;
                case resultado.Dos:
                    origen_x = grafica.origenx_grafico_6;
                    origen_y = grafica.origeny_grafico_6;
                    alto_grafico = grafica.alto_grafico_6;
                    ancho_grafico = grafica.ancho_grafico_6;
                    break;
                case resultado.Equis:
                    origen_x = grafica.origenx_grafico_4;
                    origen_y = grafica.origeny_grafico_4;
                    alto_grafico = grafica.alto_grafico_4;
                    ancho_grafico = grafica.ancho_grafico_4;
                    break;
                default:
                    origen_x =0;
                    origen_y =0;
                    alto_grafico =0;
                    ancho_grafico =0;
                    break;
            }//signo
            
            // dibuja las barras
            pincel.Color = color;
            ancho_barra = ancho_grafico / informacion_grafica_signos.MAX_COMBINACIONES_JORNADA;
            if (estilo_del_grafico == tipo_grafico.BarrasGruesas) pincel.Width = 3;
            for (int_aux = 0; int_aux < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; int_aux++){

                alto_barra = (int)(alto_grafico * ((float)frecuencia[int_aux] / (float)total_jornadas));
                if (alto_barra <= 2) { alto_barra = 0; } // si la barra queda de 1 o 2 pixel de alto ni la dibujamos
                x = origen_x + (ancho_barra * int_aux);
                y = origen_y + alto_grafico - alto_barra;
                lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);
            
            }//for

        }//DibujaProbabilidad


       /*Description:
       *   Procedimiento que dibuja la grfica de probabilidad acumulada del signo indicado
       * Recives:
       * Returns:
       */
        private void DibujaProbabilidadAcumulada(int[] frecuencia, int total_jornadas, resultado signo, tipo_grafico estilo_del_grafico, Color color)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);

            float float_aux;

            int int_aux;
            int origen_x;
            int origen_y;
            int alto_grafico;
            int ancho_grafico;
            int ancho_barra;
            int alto_barra;
            int x;
            int y;

            switch (signo){
                case resultado.Uno:
                    origen_x = grafica.origenx_grafico_1;
                    origen_y = grafica.origeny_grafico_1;
                    alto_grafico = grafica.alto_grafico_1;
                    ancho_grafico = grafica.ancho_grafico_1;
                    break;
                case resultado.Dos:
                    origen_x = grafica.origenx_grafico_5;
                    origen_y = grafica.origeny_grafico_5;
                    alto_grafico = grafica.alto_grafico_5;
                    ancho_grafico = grafica.ancho_grafico_5;
                    break;
                case resultado.Equis:
                    origen_x = grafica.origenx_grafico_3;
                    origen_y = grafica.origeny_grafico_3;
                    alto_grafico = grafica.alto_grafico_3;
                    ancho_grafico = grafica.ancho_grafico_3;
                    break;
                default:
                    origen_x = 0;
                    origen_y = 0;
                    alto_grafico = 0;
                    ancho_grafico = 0;
                    break;
            }//signo

            // dibuja las barras
            pincel.Color = color;
            ancho_barra = ancho_grafico / informacion_grafica_signos.MAX_COMBINACIONES_JORNADA;
            if (estilo_del_grafico == tipo_grafico.BarrasGruesas) pincel.Width = 3;
            float_aux = 1;
            for (int_aux = 0; int_aux < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; int_aux++)
            {
                float_aux = float_aux - ((float)frecuencia[int_aux] / (float)total_jornadas);
                alto_barra = (int)(alto_grafico * float_aux);
                if (alto_barra <= 2) { alto_barra = 0; } // si la barra queda de 1 o 2 pixel de alto ni la dibujamos
                x = origen_x + (ancho_barra * int_aux);
                y = origen_y + alto_grafico - alto_barra;
                lienzo.DrawRectangle(pincel, x, y, ancho_barra, alto_barra);
            }//for

        }//DibujaFrecuencia


        /*Description:
        *   Procedimiento que dibuja los ejes de coordenadas y la escala
        * Recives:
        * Returns:
        */
        private void DibujaEjesProbabilidad(resultado signo)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 10);
            Font drawFont_pequena = new Font("Arial", 8);
            SolidBrush brocha = new SolidBrush(Color.Black);

            int x, y;
            int ancho_barra;

            int aux_int;

            int ancho_grafico=0;
            int alto_grafico = 0;
            int origenx_grafico = 0;
            int origeny_grafico = 0;


            // tomamos las coordenadas de la grafica que toca
            switch (signo)
            {
                case resultado.Uno:
                   ancho_grafico = grafica.ancho_grafico_1;
                   alto_grafico = grafica.alto_grafico_1;
                   origenx_grafico = grafica.origenx_grafico_1;
                   origeny_grafico = grafica.origeny_grafico_1;
                   break;
               case resultado.Equis:
                   ancho_grafico = grafica.ancho_grafico_3;
                   alto_grafico = grafica.alto_grafico_3;
                   origenx_grafico = grafica.origenx_grafico_3;
                   origeny_grafico = grafica.origeny_grafico_3;
                   break;
               case resultado.Dos:
                   ancho_grafico = grafica.ancho_grafico_5;
                   alto_grafico = grafica.alto_grafico_5;
                   origenx_grafico = grafica.origenx_grafico_5;
                   origeny_grafico = grafica.origeny_grafico_5;
                   break;
            }//switch

            // dibuja el eje de coordenadas X y el Y
            ancho_barra = ancho_grafico / informacion_grafica_signos.MAX_COMBINACIONES_JORNADA;
            brocha.Color = Color.Black;
            lienzo.DrawRectangle(pincel, origenx_grafico, origeny_grafico, ancho_grafico, alto_grafico);

            // printa la escala del eje X            
            y = origeny_grafico + alto_grafico;
            for (aux_int = 0; aux_int < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; aux_int++)
            {
                x = origenx_grafico + (ancho_barra * aux_int) + (int)(ancho_barra / 2);
                lienzo.DrawString(aux_int.ToString(), drawFont_pequena, brocha, x - 4, y + 7);
            }//for

            // printa la escala del eje Y
            // 0
            x = origenx_grafico;
            y = origeny_grafico + alto_grafico;
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
            lienzo.DrawString("0", drawFont, brocha, x - 40, y - 10);

            // 0,25
            y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.25);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
            lienzo.DrawString("0,25", drawFont, brocha, x - 40, y - 10);
            
            // 0,5
            y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.5);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
            lienzo.DrawString("0,5", drawFont, brocha, x - 40, y - 10);

            // 0,75
            y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.75);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
            lienzo.DrawString("0,75", drawFont, brocha, x - 40, y - 10);

            // 1
            x = origenx_grafico;
            y = origeny_grafico + alto_grafico - (int)(alto_grafico);
            lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
            lienzo.DrawString("1", drawFont, brocha, x - 40, y - 5);

        }//DibujaEjesGraficaFrecuencia


        /*Description:
        * Procedimiento que dibuja los ejes de coordenadas y la escala
        * Recives:
        * Returns:
        */
        private void DibujaEjesProbabilidadAcumulada(resultado signo)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 10);
            Font drawFont_pequena = new Font("Arial", 8);
            SolidBrush brocha = new SolidBrush(Color.Black);

            int x, y;
            int ancho_barra;

            int aux_int;
            
            int ancho_grafico=0;
            int alto_grafico = 0;
            int origenx_grafico = 0;
            int origeny_grafico = 0;

             // tomamos las coordenadas de la grafica que toca
             switch (signo)
             {
                 case resultado.Uno:
                     ancho_grafico = grafica.ancho_grafico_2;
                     alto_grafico = grafica.alto_grafico_2;
                     origenx_grafico = grafica.origenx_grafico_2;
                     origeny_grafico = grafica.origeny_grafico_2;
                     break;
                 case resultado.Equis:
                     ancho_grafico = grafica.ancho_grafico_4;
                     alto_grafico = grafica.alto_grafico_4;
                     origenx_grafico = grafica.origenx_grafico_4;
                     origeny_grafico = grafica.origeny_grafico_4;
                     break;
                 case resultado.Dos:
                     ancho_grafico = grafica.ancho_grafico_6;
                     alto_grafico = grafica.alto_grafico_6;
                     origenx_grafico = grafica.origenx_grafico_6;
                     origeny_grafico = grafica.origeny_grafico_6;
                     break;
             }//switch
             
             // dibuja el eje de coordenadas X y el Y
             ancho_barra = ancho_grafico / informacion_grafica_signos.MAX_COMBINACIONES_JORNADA;
             brocha.Color = Color.Black;
             lienzo.DrawRectangle(pincel, origenx_grafico, origeny_grafico, ancho_grafico, alto_grafico);

             // printa la escala del eje X            
             y = origeny_grafico + alto_grafico;
             for (aux_int = 0; aux_int < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; aux_int++)
             {
                 x = origenx_grafico + (ancho_barra * aux_int) + (int)(ancho_barra / 2);
                 lienzo.DrawString(aux_int.ToString(), drawFont_pequena, brocha, x - 4, y + 7);
             }//for

             // printa la escala del eje Y
             // 0
             x = origenx_grafico;
             y = origeny_grafico + alto_grafico;
             lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
             lienzo.DrawString("0", drawFont, brocha, x - 40, y - 10);

             // 0,25
             y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.25);
             lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
             lienzo.DrawString("0,25", drawFont, brocha, x - 40, y - 10);

             // 0,5
             y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.5);
             lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
             lienzo.DrawString("0,5", drawFont, brocha, x - 40, y - 10);
            
             // 0,75
             y = origeny_grafico + alto_grafico - (int)(alto_grafico * 0.75);
             lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
             lienzo.DrawString("0,75", drawFont, brocha, x - 40, y - 10);

             // 1
             x = origenx_grafico;
             y = origeny_grafico + alto_grafico - (int)(alto_grafico);
             lienzo.DrawLine(pincel, x - 5, y, x + ancho_grafico, y);
             lienzo.DrawString("1", drawFont, brocha, x - 40, y - 5);

        }//DibujaEjesProbabilidadAcumulada


        /*Description:
        *   Funcion que calucla las estadisticas de los signos (1 X y 2) en el rango de temporadas
        *   especificado por id_temporada_1 e id_temporada_2 de la divisin especificaa en division
        * Recives:
        *   Por valor:
        *      division: con la division sobre la queremos realizar los calculos
        *      id_temporada_orig: con el identificador de la temporada origen ( la mas antigua del rango)
        *      id_temporada_fin: con el identificador de la temporada final ( la mas reciente del rango)
        * Returns:
        */
        private void AplicaEstaditicasSignos(Analizador.tipo_division division, int id_temporda_orig, int id_temporda_fin)
        {
            List<int> Lista_Temporadas_Id = new List<int>();
            List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();
            List<int> Lista_Jornadas = new List<int>();

            List<string> Lista_Equipo1 = new List<string>();
            List<int> Lista_Goles_Equipo1 = new List<int>();
            List<string> Lista_Equipo2 = new List<string>();
            List<int> Lista_Goles_Equipo2 = new List<int>();

            int total_temporadas = 0;
            int total_jornadas = 0;
            int total_partidos_jornada = 0;
            int maximo_total_partidos_jornada = 0;

            float[] array_p_aciertos = new float[informacion_grafica_signos.MAX_COMBINACIONES_JORNADA];
            int jornadas_temporada_analizadas = 0;
            int jornadas_totales_analizadas = 0;
            string aux_string;
            string aux_string2;
            string aux_string3;
            string aux_string4;
            float aux_float;

            // principalmente se usan para llamar a la funcion de probabilidades
            int unos = 0;
            int equis = 0;
            int doses = 0;

            // arrays donde se guardan las frecuencias parciales calculadas para cada temporada
            int[] array_frecuencia_1_temporada = new int[informacion_grafica_signos.MAX_COMBINACIONES_JORNADA];
            int[] array_frecuencia_X_temporada = new int[informacion_grafica_signos.MAX_COMBINACIONES_JORNADA];
            int[] array_frecuencia_2_temporada = new int[informacion_grafica_signos.MAX_COMBINACIONES_JORNADA];

            // variables auxiliares
            int aux_int = 0;
            int aux_int2 = 0;
            int aux_int3 = 0;
            int aux_int4 = 0;

            double double_aux;


            // solo hace que se muestre por pantalla el mensaje general de inicio de test
            textBox1.Text = textBox1.Text + "Iniciado el calculo de estadisticas de signos\r\n";

            // obtenemos el rango de temporadas de la BBDD
            Lista_Temporadas_Id.Clear();
            Lista_Temporadas_Anio1_Anio2.Clear();            
            total_temporadas = Analizador.ConsultaRangoTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2, division,id_temporda_orig,id_temporda_fin);

            textBox1.Text = textBox1.Text + "ATENCION: recordar que los valores obtenidos son slo aproximaciones ( consultar ayuda on-line )\r\n";

            // solo muestra por pantalla el mensaje indicando cuantas y que temporadas se van a analizar
            switch (division)
            {
                case Analizador.tipo_division.Primera:
                    textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString() + " temporadas de 1a division ( de " + Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] + " a " + Lista_Temporadas_Anio1_Anio2[0] + ")\r\n";
                    break;
                case Analizador.tipo_division.Segunda:
                    textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString() + " temporadas de 2a division ( de " + Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] + " a " + Lista_Temporadas_Anio1_Anio2[0] + ")\r\n";
                    break;
                case Analizador.tipo_division.PrimeraSegunda:
                    textBox1.Text = textBox1.Text + "Se analizaran " + total_temporadas.ToString() + " temporadas de 1a y 2a division ( de " + Lista_Temporadas_Anio1_Anio2[Lista_Temporadas_Anio1_Anio2.Count - 1] + " a " + Lista_Temporadas_Anio1_Anio2[0] + ")\r\n";
                    break;
                default:
                    break;
            }//switch

            // inicializa el array en que se guardan los aciertos de la temporada
            for (aux_int4 = 0; aux_int4 < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; aux_int4++)
            {
                grafica.array_frecuencia_1_totales[aux_int4] = 0;
                grafica.array_frecuencia_X_totales[aux_int4] = 0;
                grafica.array_frecuencia_2_totales[aux_int4] = 0;
            }//for

            // se procesa cada una de las temporadas que hay analizar
            for (aux_int = 0; aux_int < total_temporadas; aux_int++)
            {

                // antes de procesar la temporada incializamos el array
                for (aux_int4 = 0; aux_int4 < informacion_grafica_signos.MAX_COMBINACIONES_JORNADA; aux_int4++)
                {
                    array_frecuencia_1_temporada[aux_int4] = 0;
                    array_frecuencia_X_temporada[aux_int4] = 0;
                    array_frecuencia_2_temporada[aux_int4] = 0;
                }//for

                // para cada temporada obtenemos el total de jornadas
                Lista_Jornadas.Clear();
                total_jornadas = Analizador.ConsultaNumJornadasTemporada(Lista_Temporadas_Id[aux_int], Lista_Jornadas, division);
                jornadas_temporada_analizadas = 0;
                maximo_total_partidos_jornada = 0;
                for (aux_int2 = 0; aux_int2 < total_jornadas; aux_int2++)
                {

                    // para cada jornada obtenemos los partidos que se jugaron y sus resultados            
                    Lista_Equipo1.Clear();
                    Lista_Equipo2.Clear();
                    Lista_Goles_Equipo1.Clear();
                    Lista_Goles_Equipo2.Clear();             

                    // cuando se combinan 1a y 2a division es posible que total_partidos_jornada varie en las ultimas jorndas puesto que 1a tiene menos jornadas que 2a
                    total_partidos_jornada = Analizador.ConsultaPartidosJornada(Lista_Temporadas_Id[aux_int], Lista_Jornadas[aux_int2], Lista_Equipo1, Lista_Equipo2, Lista_Goles_Equipo1, Lista_Goles_Equipo2, division);
                    // revisamos la variable que usamos para printar por pantalla cual es el numero de partidos por jornada (tenemos que informar del mayor puesto que algunas jornadas no tienen partidos )
                    if (total_partidos_jornada > maximo_total_partidos_jornada) { maximo_total_partidos_jornada = total_partidos_jornada; }
                    
                    // procesamos cada uno de los partidos de la jornada para calcular el total de 1os, Xis y 2ses que se han producido
                    unos = 0;
                    equis = 0;
                    doses = 0;
                    for (aux_int3 = 0; aux_int3 < total_partidos_jornada; aux_int3++)
                    {

                        // calculamos el signo es decir (si salio 1, X o 2) y actualizamos el
                        // correspondiente contador de signos de esa jornada
                        if (Lista_Goles_Equipo1[aux_int3] > Lista_Goles_Equipo2[aux_int3])
                        {
                            unos++;
                        }
                        else if ((Lista_Goles_Equipo1[aux_int3] < Lista_Goles_Equipo2[aux_int3]))
                        {
                            doses++;
                        }
                        else
                        {
                            equis++;
                        }//if

                    }//for

                    // una vez se ha contabilizado la frecuencia de los diferentes signos en esa
                    // joranada se actualizan los valores en el array en que se guarda la frecuencia
                    // de signos de la temporada
                    array_frecuencia_1_temporada[unos]++;
                    array_frecuencia_X_temporada[equis]++;
                    array_frecuencia_2_temporada[doses]++;

                    jornadas_temporada_analizadas++;
                    jornadas_totales_analizadas++;

                }//for

                // aadimos los valores obtenidos de la temporada recien calculada a los valores totales
                for (aux_int4 = 0; aux_int4 < maximo_total_partidos_jornada; aux_int4++)
                {
                    grafica.array_frecuencia_1_totales[aux_int4] = grafica.array_frecuencia_1_totales[aux_int4] + array_frecuencia_1_temporada[aux_int4];
                    grafica.array_frecuencia_X_totales[aux_int4] = grafica.array_frecuencia_X_totales[aux_int4] + array_frecuencia_X_temporada[aux_int4];
                    grafica.array_frecuencia_2_totales[aux_int4] = grafica.array_frecuencia_2_totales[aux_int4] + array_frecuencia_2_temporada[aux_int4];

                }//for

                // si esta seleccionada la opcion dibujamos el grafico de distribucion de la probabilidad de la temporada que se acaba de procesar
                if (checkBox1.Checked == true)
                {

                    // dibuja a la probabilidad
                    DibujaProbabilidad(array_frecuencia_1_temporada, jornadas_temporada_analizadas, resultado.Uno, tipo_grafico.Barras, Color.Black);
                    DibujaProbabilidad(array_frecuencia_X_temporada, jornadas_temporada_analizadas, resultado.Equis, tipo_grafico.Barras, Color.Black);
                    DibujaProbabilidad(array_frecuencia_2_temporada, jornadas_temporada_analizadas, resultado.Dos, tipo_grafico.Barras, Color.Black);
                    
                    // dibuja a probabilidad acumulada
                    DibujaProbabilidadAcumulada(array_frecuencia_1_temporada, jornadas_temporada_analizadas, resultado.Uno, tipo_grafico.Barras, Color.Black);
                    DibujaProbabilidadAcumulada(array_frecuencia_X_temporada, jornadas_temporada_analizadas, resultado.Equis, tipo_grafico.Barras, Color.Black);
                    DibujaProbabilidadAcumulada(array_frecuencia_2_temporada, jornadas_temporada_analizadas, resultado.Dos, tipo_grafico.Barras, Color.Black);

                    grafica.arrays_inicializados = true;// sealizamos tambien el flag que indica que el array tiene valores                    

                    // tras dibujar se refresca el lienzo
                    Refresh();

                }//if

                // muestra el texto informativo por pantalla con                 
                textBox1.Text = textBox1.Text + "Analizadas las " + total_jornadas.ToString() + " jornadas de la temporada " + Lista_Temporadas_Anio1_Anio2[aux_int] + " ( " + maximo_total_partidos_jornada.ToString() + " partidos por jornada )\r\n"; ;

                Application.DoEvents();

            }//for

            grafica.total_jornadas_anailzadas = jornadas_totales_analizadas; 

            // dibujamos las probabilidades totales de cada signo
            DibujaProbabilidad(grafica.array_frecuencia_1_totales, grafica.total_jornadas_anailzadas, resultado.Uno, tipo_grafico.BarrasGruesas, Color.Red);
            DibujaProbabilidad(grafica.array_frecuencia_X_totales, grafica.total_jornadas_anailzadas, resultado.Equis, tipo_grafico.BarrasGruesas, Color.Red);
            DibujaProbabilidad(grafica.array_frecuencia_2_totales, grafica.total_jornadas_anailzadas, resultado.Dos, tipo_grafico.BarrasGruesas, Color.Red);

            // dibujamos la probabilidad acumulada total de cada signo
            DibujaProbabilidadAcumulada(grafica.array_frecuencia_1_totales, grafica.total_jornadas_anailzadas, resultado.Uno, tipo_grafico.BarrasGruesas, Color.Red);
            DibujaProbabilidadAcumulada(grafica.array_frecuencia_X_totales, grafica.total_jornadas_anailzadas, resultado.Equis, tipo_grafico.BarrasGruesas, Color.Red);
            DibujaProbabilidadAcumulada(grafica.array_frecuencia_2_totales, grafica.total_jornadas_anailzadas, resultado.Dos, tipo_grafico.BarrasGruesas, Color.Red);

            // tras dibujar se refresca el lienzo
            Refresh();

            // se muestra por pantalla la probabilidad media de los 1s
            textBox1.Text = textBox1.Text + "Probabilidad media de apariciones del '1':\r\n";
            for (aux_int4 = 0; aux_int4 <=maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = (((float)grafica.array_frecuencia_1_totales[aux_int4] / (float)jornadas_totales_analizadas) * 100);
                aux_string = String.Format("{0:000.00}", aux_float);
                aux_string2 = String.Format("{0:00}", aux_int4);
                aux_string3 = String.Format("{0:000}", grafica.array_frecuencia_1_totales[aux_int4]);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + aux_string2 + " 1 (Uno) " + aux_string3 + "/" + jornadas_totales_analizadas.ToString() + " ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";            
            }//for

            // se muestra por pantalla la probabilidad acumulada  de los 1s
            textBox1.Text = textBox1.Text + "Probabilidad acumulada de apariciones del '1':\r\n";
            aux_float = 1;
            for (aux_int4 = 0; aux_int4 < maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = aux_float - ((float)grafica.array_frecuencia_1_totales[aux_int4] / (float)jornadas_totales_analizadas);
                aux_string = String.Format("{0:000.00}", (aux_float * 100));
                aux_string2 = String.Format("{0:00}", aux_int4);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + "Ms de " + aux_string2 + " 1 (Uno) ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";
            }//for

            // se muestra por pantalla la probabilidad media de las Xs
            textBox1.Text = textBox1.Text + "Probabilidad media de apariciones de la 'X':\r\n";
            for (aux_int4 = 0; aux_int4 <= maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = (((float)grafica.array_frecuencia_X_totales[aux_int4] / (float)jornadas_totales_analizadas) * 100);
                aux_string = String.Format("{0:000.00}", aux_float);
                aux_string2 = String.Format("{0:00}", aux_int4);
                aux_string3 = String.Format("{0:000}", grafica.array_frecuencia_X_totales[aux_int4]);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + aux_string2 + " X (Equis) " + aux_string3 + "/" + jornadas_totales_analizadas.ToString() + " ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";
            }//for

            // se muestra por pantalla la probabilidad acumulada  de las Xs
            textBox1.Text = textBox1.Text + "Probabilidad acumulada de apariciones de la 'X':\r\n";
            aux_float = 1;
            for (aux_int4 = 0; aux_int4 < maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = aux_float - ((float)grafica.array_frecuencia_X_totales[aux_int4] / (float)jornadas_totales_analizadas);
                aux_string = String.Format("{0:000.00}", (aux_float * 100));
                aux_string2 = String.Format("{0:00}", aux_int4);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + "Ms de " + aux_string2 + " X (Equis) ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:"+ aux_string + "% \r\n";
            }//for

            // se muestra por pantalla la probabilidad media de los 2s
            textBox1.Text = textBox1.Text + "Probabilidad media de apariciones del '2':\r\n";
            for (aux_int4 = 0; aux_int4 <= maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = (((float)grafica.array_frecuencia_2_totales[aux_int4] / (float)jornadas_totales_analizadas) * 100);
                aux_string = String.Format("{0:000.00}", aux_float);
                aux_string2 = String.Format("{0:00}", aux_int4);
                aux_string3 = String.Format("{0:000}", grafica.array_frecuencia_2_totales[aux_int4]);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + aux_string2 + " 2 (Dos) " + aux_string3 + "/" + jornadas_totales_analizadas.ToString() + " ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";            
            }//for

            // se muestra por pantalla la probabilidad acumulada  de los 2s
            textBox1.Text = textBox1.Text + "Probabilidad acumulada de apariciones del '2':\r\n";
            aux_float = 1;
            for (aux_int4 = 0; aux_int4 < maximo_total_partidos_jornada; aux_int4++)
            {
                aux_float = aux_float - ((float)grafica.array_frecuencia_2_totales[aux_int4] / (float)jornadas_totales_analizadas);
                aux_string = String.Format("{0:000.00}", (aux_float * 100));
                aux_string2 = String.Format("{0:00}", aux_int4);
                double_aux = ((double)aux_int4 / (double)maximo_total_partidos_jornada) * Convert.ToDouble(textBox2.Text);
                aux_string4 = String.Format("{0:00.0}", double_aux);
                textBox1.Text = textBox1.Text + "Ms de " + aux_string2 + " 2 (Dos) ( " + aux_string4 + " ajustado a " + textBox2.Text + " ) P:" + aux_string + "% \r\n";
            }//for

            textBox1.Text = textBox1.Text + "Fin del test\r\n";

        }//AplicaEstaditicasSignos
        
        
        /*Description:
        *   Funcion que pinta todos los graficos del formulario
        * Recives:
        *   Por referencia:
        * Returns:
        */
        private void DibujaTodo(){
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);

            // si esta activado el checkbox borrar al refrescar borramos todo
            if (checkBox2.Checked == true){
                lienzo.Clear(Form3.DefaultBackColor);
            }

            // dibujamos los ejes de las graficas
            DibujaEjesProbabilidad(resultado.Uno);
            DibujaEjesProbabilidad(resultado.Equis);
            DibujaEjesProbabilidad(resultado.Dos);

            // dibujamos los ejes de las graficas de probabilidad Acumulada
            DibujaEjesProbabilidadAcumulada(resultado.Uno);
            DibujaEjesProbabilidadAcumulada(resultado.Equis);
            DibujaEjesProbabilidadAcumulada(resultado.Dos);

            // si el array tiene valores dibujamos las graficas
            if (grafica.arrays_inicializados == true)
            {
                // dibujamos las probabilidades totales de cada signo
                DibujaProbabilidad(grafica.array_frecuencia_1_totales, grafica.total_jornadas_anailzadas, resultado.Uno, tipo_grafico.BarrasGruesas, Color.Red);
                DibujaProbabilidad(grafica.array_frecuencia_X_totales, grafica.total_jornadas_anailzadas, resultado.Equis, tipo_grafico.BarrasGruesas, Color.Red);
                DibujaProbabilidad(grafica.array_frecuencia_2_totales, grafica.total_jornadas_anailzadas, resultado.Dos, tipo_grafico.BarrasGruesas, Color.Red);

                // dibujamos la probabilidad acumulada total de cada signo
                DibujaProbabilidadAcumulada(grafica.array_frecuencia_1_totales, grafica.total_jornadas_anailzadas, resultado.Uno, tipo_grafico.BarrasGruesas, Color.Red);
                DibujaProbabilidadAcumulada(grafica.array_frecuencia_X_totales, grafica.total_jornadas_anailzadas, resultado.Equis, tipo_grafico.BarrasGruesas, Color.Red);
                DibujaProbabilidadAcumulada(grafica.array_frecuencia_2_totales, grafica.total_jornadas_anailzadas, resultado.Dos, tipo_grafico.BarrasGruesas, Color.Red);

            }//if

        }
      
        public Form6()
        {
            InitializeComponent();
        }


        private void button2_Click(object sender, EventArgs e)
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);

            // se inicializa el array con las graficas
            grafica.inicializa();
            // pintamos en el lienzo
            DibujaTodo();
            // forzamos la llamada al metodo Paint()
            Refresh();

            //la estadistica de signos se aplica a una u otra temporada dependiendo de cual tengamos seleccionada
            if (radioButton1.Checked == true)
            {
                AplicaEstaditicasSignos( Analizador.tipo_division.Primera , Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }
            else if (radioButton2.Checked == true)
            {
                AplicaEstaditicasSignos(Analizador.tipo_division.Segunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]) ;
            }
            else if (radioButton3.Checked == true)
            {
                AplicaEstaditicasSignos(Analizador.tipo_division.PrimeraSegunda, Lista_Temporadas_Id[comboBox1.SelectedIndex], Lista_Temporadas_Id[comboBox2.SelectedIndex]);
            }//if

        }

        private void Form6_Load(object sender, EventArgs e)
        {
            int total_temporadas;
            int int_aux;

            // se llenan las ComboBoxes con todas las temporadas disponibles 
            total_temporadas = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (int_aux = 0; int_aux < total_temporadas; int_aux++)
            {
                comboBox1.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);
                comboBox2.Items.Add(Lista_Temporadas_Anio1_Anio2[int_aux]);
            }//for
            
            // inicializamos con la primera y ulima temporada
            comboBox1.Text = Lista_Temporadas_Anio1_Anio2[total_temporadas - 1].ToString();
            comboBox2.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();

            // creamos el bitmap que sera el lienzo donde dibujaremos pintamos ( en l para tener persistencia de la imagen sino al mover los forms, se borran )
            bitmap_con_graficos = new Bitmap(this.ClientRectangle.Width, this.ClientRectangle.Height, System.Drawing.Imaging.PixelFormat.Format24bppRgb);

            // pintamos en el lienzo
            DibujaTodo();

            // forzamos la llamada al metodo Paint()
            Refresh();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            // han pulsado el boton refrescar asi que limpiamos y repintamos todo

            // pintamos en el lienzo
            DibujaTodo();

            // forzamos la llamada al metodo Paint()
            Refresh();

        }

        private void Form6_FormClosing(object sender, FormClosingEventArgs e)
        {
            LFSuite.Form1 FormPadre = (LFSuite.Form1)this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_estadisticas_signos = null;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // cerramos el formulario ( se llamara al evento closing que gestiona el tema del puntero en el parent etc.)
            this.Close();
        }

        private void Form6_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphicsObj = e.Graphics;

            graphicsObj.DrawImage(bitmap_con_graficos, 0, 0, bitmap_con_graficos.Width, bitmap_con_graficos.Height);

            graphicsObj.Dispose();

        }

    }
  
    class informacion_grafica_signos
    {
        public const int MAX_COMBINACIONES_JORNADA = 22;
        public const int MAX_RANGO_INTERVALOS_RELATIVOS = 20;
        
        // grafico 1 ACUMULADA 1
        public int ancho_grafico_1 = 277;
        public int alto_grafico_1 = 100;
        public int origenx_grafico_1 = 50;
        public int origeny_grafico_1 = 35;

        // grafico 2 FRECUENCIA 1
        public int ancho_grafico_2 = 277;
        public int alto_grafico_2 = 100;
        public int origenx_grafico_2 = 50;
        public int origeny_grafico_2 = 165;

        // grafico 3 ACUMULADA X
        public int ancho_grafico_3 = 277;
        public int alto_grafico_3 = 100;
        public int origenx_grafico_3 = 377;
        public int origeny_grafico_3 = 35;

        // grafico 4 FRECUENCIA X
        public int ancho_grafico_4 = 277;
        public int alto_grafico_4 = 100;
        public int origenx_grafico_4 = 377;
        public int origeny_grafico_4 = 165;

        // grafico 5   ACUMULADA 2
        public int ancho_grafico_5 = 277;
        public int alto_grafico_5 = 100;
        public int origenx_grafico_5 = 704;
        public int origeny_grafico_5 = 35;

        // grafico 6 FRECUENCIA 2
        public int ancho_grafico_6 = 277;
        public int alto_grafico_6 = 100;
        public int origenx_grafico_6 = 704;
        public int origeny_grafico_6 = 165;

        public int total_jornadas_anailzadas = 0;

        public int[] array_frecuencia_1_totales = new int[MAX_COMBINACIONES_JORNADA];
        public int[] array_frecuencia_X_totales = new int[MAX_COMBINACIONES_JORNADA];
        public int[] array_frecuencia_2_totales = new int[MAX_COMBINACIONES_JORNADA];
        public bool arrays_inicializados;// para saber si hay datos validos en los arrays

        public informacion_grafica_signos()
        {
            uint ui_aux;

            for (ui_aux = 0; ui_aux < MAX_COMBINACIONES_JORNADA; ui_aux++){
                array_frecuencia_1_totales[ui_aux] = 0;
                array_frecuencia_X_totales[ui_aux] = 0;
                array_frecuencia_2_totales[ui_aux] = 0;
            }
            arrays_inicializados = false;

        }

        public void inicializa()
        {
            uint ui_aux;

            for (ui_aux = 0; ui_aux < MAX_COMBINACIONES_JORNADA; ui_aux++)
            {
                array_frecuencia_1_totales[ui_aux] = 0;
                array_frecuencia_X_totales[ui_aux] = 0;
                array_frecuencia_2_totales[ui_aux] = 0;
            }//for
            arrays_inicializados = false;

        }

    }//informacion_grafica_signos
}