using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* L F S U I T E     2 0 1 1
 * www.tolaemon.com/lfusite
 * tolaemon 1/10/2011
 * 
 * La utilizacin del codigo de este programa implica la aceptacin de los siguientes puntos:
 * 
 * -Licencia: LFSuite se distribuye bajo licencia "Creative Commons by-nc-sa 3.0", lo que significa que eres libre de compartir ( copiar, distribuir y transmitir ) 
 * y modificar ( readaptar el trabajo ) bajo las siguientes condiciones:
 * -Reconocimiento (Attribution): En cualquier explotacin de la obra autorizada por la licencia har falta reconocer la autora.
 * -No Comercial (Non commercial): La explotacin de la obra queda limitada a usos no comerciales.
 * -Compartir Igual (Share alike): La explotacin autorizada incluye la creacin de obras derivadas siempre que mantengan la misma licencia al ser divulgadas.
 *
 * -Garanta: el autor proporciona este software "tal cual es", sin garantas de ningn tipo. El usuario es el nico responsable de determinar lo apropiado de 
 * utilizar, y modificar este trabajo asumiendo y valorando, a su vez, los riesgos inherentes a ello. Bajo ningn concepto el autor ser responsable de posibles 
 * prdidas, daos, tanto directos como indirectos, especiales o accidentales resultantes de su utilizacin an y cuando este haya sido avisado de la posibilidad
 * de tales daos. 
*/

namespace LFSuite
{
    
    public partial class Form7 : Form
    {
        // con toda la informacion necesaria para poder dibunar las grficas de trayectrias de los diferentes equipos
        informacion_grafica_trayectorias grafica = new informacion_grafica_trayectorias();
        
        // bitmap donde pintaremos los graficos, asi seran persistentes, es decir no se borraran al mover los formularios etc.
        private System.Drawing.Bitmap bitmap_con_graficos; 

        // se utiliza para guardar los nombres de los equipos ( y sus Ids ) que vamos a insertar en la ComboBox
        List<string> ListaEquiposEquipo = new List<string>();
        List<int> ListaEquiposId = new List<int>();

        // se utilizan para guardar la informacin de todas las temporadas que se insertara en la ComboBox y sus identificadores
        List<string> Lista_Temporadas_Anio1_Anio2 = new List<string>();
        List<int> Lista_Temporadas_Id = new List<int>();
        
        public Form7()
        {
            InitializeComponent();
        }



        /*Description:
        *   Dibuja los ejes de la grafica de Trayectorias de temporadas acumuladas, las marcas y etiquetas de la 
        * escala no se pueden dibujar pq aun no conocemos los valores que han de tener.
        * Recives:
        * Por valor:
        * Returns:
        */
        private void DibujaEjesGraficaTrayectoriasAcumuladas()
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);         
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);            
            uint posx;
            uint posy;
            string string_aux;

            // se borra el fondo del formulario
            lienzo.Clear(this.BackColor);
            // se pinta el marco de la grfica
            lienzo.DrawRectangle(pincel, grafica.origenx, grafica.origeny - grafica.alto, grafica.ancho, grafica.alto);
            // se printa el titulo
            string_aux = "Trayectorias acumuladas";
            posx = grafica.origenx + (grafica.ancho/2)-(((uint)(string_aux.Length) *10)/2);
            posy = grafica.origeny - grafica.alto - 25;
            lienzo.DrawString(string_aux, drawFont, brocha,posx,posy );

      }



      /*Description:
      *   Dibuja los ejes de la grafica de Trayectorias, las marcas y etiquetas de la escala no se pueden
      * dibujar pq aun no conocemos los valores que han de tener hasta que no se calculen los maximos 
      * y minimos no se pueden dibujar las muescas ) 
      * Recives:
      * Por valor:
      * Returns:
      */
        private void DibujaEjesGraficaTrayectorias()
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);         
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            SolidBrush brocha = new SolidBrush(Color.Black);
            uint posx;
            uint posy;
            string string_aux;

            // se borra el fondo del formulario
            lienzo.Clear(this.BackColor);
            // se pinta el marco de la grfica
            lienzo.DrawRectangle(pincel, grafica.origenx, grafica.origeny - grafica.alto, grafica.ancho, grafica.alto);
            // se printa el titulo
            string_aux = "Trayectorias";
            posx = grafica.origenx + (grafica.ancho / 2) - (((uint)(string_aux.Length) * 10) / 2);
            posy = grafica.origeny - grafica.alto - 25;
            lienzo.DrawString(string_aux, drawFont, brocha, posx, posy);

        }



        /*Description:
        *       Toma la informacion contenida en la estructura de trayectorias y la dibuja sobre el formulario
        * Recives:
        * Por valor:
        * Returns:
        */
        private void DibujaGraficaTrayectoriasAcumuladas()
        {
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            Font drawFont_pequena = new Font("Arial", 7);
            SolidBrush brocha = new SolidBrush(Color.Black);
            
            uint puntos_equipo;

            int int_aux;
            int int_aux2;
            int int_aux3;
            int int_aux4;
            
            string string_aux;

            float AY;//incremento de Y
            float AX;//incremento de X

            float posx;
            float posy;

            float posx_previo;
            float posy_previo;

            float anchox;
            float altoy;
            uint numero_muescas;

            AY = (float)grafica.alto / (float)grafica.puntos_temporadas_acumulados_max;
            AX = (float)grafica.ancho / (float)grafica.total_jornadas_trayectoria;

            // se pintan las marcas y etiquetas del eje X
            posx = grafica.origenx;
            posy = grafica.origeny;
            numero_muescas = grafica.num_temporadas;

            for (int_aux = 0; int_aux < numero_muescas; int_aux++)
            {
                // pinta la muesca               
                lienzo.DrawLine(pincel, posx, posy + 10, posx, posy);

                // printa la etiqueta ( nombre ) de la temporada ( aos )
                if (grafica.num_temporadas < 10)
                {
                    // si hay menos de 10 temporadas en la grafica printamos el titulo de todas
                    string_aux = grafica.array_nombres_temporada[int_aux];
                    lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                }
                else if (grafica.num_temporadas < 30)
                {
                    // si hay entre 10 y 20 temporadas en la grafica printamos el titulo de 1 cada 2                    
                    if ((int_aux % 2) == 0)
                    {
                        string_aux = grafica.array_nombres_temporada[int_aux];
                        lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                    }//if
                }
                else 
                {
                    // si hay mas de temporadas en la grafica printamos el titulo de 1 cada 5
                    if ((int_aux % 5) == 0)
                    {
                        string_aux = grafica.array_nombres_temporada[int_aux];
                        lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                    }//if
                }//if

                // incrementamos la variable de posicion X de la muesca
                anchox = AX * grafica.array_jornadas_temporada[int_aux];
                posx = posx + anchox;

            }//for (int_aux = 0

            // se pintan las marcas y etiquetas del eje Y
            posx = grafica.origenx;
            posy = grafica.origeny;

            if (grafica.puntos_temporadas_acumulados_max <= 100){
                // si el maximo de puntos es inferior o igual a 100
                altoy = 10;
            }
            else if (grafica.puntos_temporadas_acumulados_max <= 500)
            {
                // si el maximo de puntos es inferior o igual a 500
                altoy = 50;
            }else if (grafica.puntos_temporadas_acumulados_max <= 1000){
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 100;
            }else if (grafica.puntos_temporadas_acumulados_max <= 5000){
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 500;
            }else if (grafica.puntos_temporadas_acumulados_max <= 10000){
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 1000;
            }else{
                altoy = 2500;
            }//if
            
            numero_muescas = (uint) (grafica.puntos_temporadas_acumulados_max / altoy );

            for (int_aux = 0; int_aux <= numero_muescas; int_aux++)
            {
                // pinta la muesca                
                lienzo.DrawLine(pincel, posx - 5, posy, posx + 5, posy);

                // pintamos la linea discontinua horizontal de cada muesca
                for (int_aux2 = 0; int_aux2 < grafica.ancho; int_aux2 = int_aux2 + 10)
                {
                    lienzo.DrawLine(pincel, grafica.origenx + int_aux2, posy, grafica.origenx + int_aux2 + 2, posy);
                
                }//for

                // printamos el titulo en la muesca
                string_aux=Convert.ToString(altoy*int_aux);
                lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx-(string_aux.Length*10), posy-6);

                // incrementamos la variable de posicion Y de la muesca
                posy = posy - (float)(altoy * AY);
            }

            // se pintan los datos

            // para cada equipo contenido en la estructura
            for (int_aux = 0; int_aux < grafica.num_equipos; int_aux++)
            {
                puntos_equipo = 0;
                pincel.Color = grafica.array_equipos[int_aux].color;
                brocha.Color = grafica.array_equipos[int_aux].color;

                // para cada joranda del equipo  
                posx = grafica.origenx;
                posy = grafica.origeny;

                posx_previo = posx;
                posy_previo = posy;

                int_aux3 = 0;
                int_aux4 = 0;
                for (int_aux2 = (int)grafica.array_equipos[int_aux].inicio_datos_equipo; int_aux2 < grafica.array_equipos[int_aux].final_datos_equipo; int_aux2++)
                {


                    // controlamos el numero de jornadas de la temporada que llevamos para ver si toca dibujar 
                    // el simbolo que indica el equipo con mas puntos en la temporada procesada
                    if (int_aux4 == grafica.array_jornadas_temporada[int_aux3])
                    {

                        // antes de restear, si hemos llegado al final de la temporada y el equipo es el que tiene mas
                        // puntos en esa temporada de los seleccionados dibujamos una marca
                        if (grafica.array_equipos[int_aux].id_equipo == grafica.array_maximos_puntos_id_equipo[int_aux3])
                        {
                            lienzo.FillEllipse(brocha, (posx - 3), (posy - 3), 6, 6);
                        }//if

                        // reseteamos las variables de control de las temporadas
                        int_aux4 = 1;
                        int_aux3++;// saltamos a la siguiente temporada

                    }
                    else
                    {

                        int_aux4++;// se incrementa el contador de jornadas de la temporada

                    }
                                      
                    puntos_equipo = puntos_equipo + grafica.array_resultados_trayectorias[int_aux2];

                    posx = posx + AX;
                    posy = grafica.origeny - (float)(puntos_equipo * AY);

                    lienzo.DrawLine(pincel, posx, posy, posx_previo, posy_previo);

                    posx_previo = posx;
                    posy_previo = posy;

                }//for

            }//for

        }//DibujaGraficaTrayectoriasAcumuladas



        /*Description:
       *       Toma la informacion contenida en la estructura de trayectorias y la dibuja sobre el formulario
       * Recives:
       * Por valor:
       * Returns:
       */
        private void DibujaGraficaTrayectorias()
        {
            Pen pincel = new Pen(Color.Black);
            Font drawFont = new Font("Arial", 12);
            Font drawFont_pequena = new Font("Arial", 7);
            SolidBrush brocha = new SolidBrush(Color.Black);
            Graphics lienzo = Graphics.FromImage(bitmap_con_graficos);

            uint puntos_equipo;

            int int_aux;
            int int_aux2;
            int int_aux3;
            int int_aux4;

            string string_aux;

            float AY;//incremento de Y
            float AX;//incremento de X

            float posx;
            float posy;

            float posx_previo;
            float posy_previo;

            float anchox;
            float altoy;
            uint numero_muescas;

            AY = (float)grafica.alto / (float)grafica.puntos_acumulados_max;
            AX = (float)grafica.ancho / (float)grafica.total_jornadas_trayectoria;

            // se pintan las marcas y etiquetas del eje X
            posx = grafica.origenx;
            posy = grafica.origeny;
            numero_muescas = grafica.num_temporadas;

            for (int_aux = 0; int_aux < numero_muescas; int_aux++)
            {
                // pinta la muesca               
                lienzo.DrawLine(pincel, posx, posy + 10, posx, posy);

                // printa la etiqueta ( nombre ) de la temporada ( aos )
                if (grafica.num_temporadas < 10)
                {
                    // si hay menos de 10 temporadas en la grafica printamos el titulo de todas
                    string_aux = grafica.array_nombres_temporada[int_aux];
                    lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                }
                else if (grafica.num_temporadas < 30)
                {
                    // si hay entre 10 y 20 temporadas en la grafica printamos el titulo de 1 cada 2                    
                    if ((int_aux % 2) == 0)
                    {
                        string_aux = grafica.array_nombres_temporada[int_aux];
                        lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                    }//if
                }
                else
                {
                    // si hay mas de temporadas en la grafica printamos el titulo de 1 cada 5
                    if ((int_aux % 5) == 0)
                    {
                        string_aux = grafica.array_nombres_temporada[int_aux];
                        lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - 25, posy + 10);
                    }//if

                }//if

                // incrementamos la variable de posicion X de la muesca
                anchox = AX * grafica.array_jornadas_temporada[int_aux];
                posx = posx + anchox;

            }//for (int_aux = 0

            // se pintan las marcas y etiquetas del eje Y
            posx = grafica.origenx;
            posy = grafica.origeny;

            if (grafica.puntos_acumulados_max <= 100)
            {
                // si el maximo de puntos es inferior o igual a 100
                altoy = 10;
            }
            else if (grafica.puntos_acumulados_max <= 500)
            {
                // si el maximo de puntos es inferior o igual a 500
                altoy = 50;
            }
            else if (grafica.puntos_acumulados_max <= 1000)
            {
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 100;
            }
            else if (grafica.puntos_acumulados_max <= 5000)
            {
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 500;
            }
            else if (grafica.puntos_acumulados_max <= 10000)
            {
                // si el maximo de puntos es inferior o igual a 1000
                altoy = 1000;
            }
            else
            {
                altoy = 2500;
            }//if

            numero_muescas = (uint)(grafica.puntos_acumulados_max / altoy);

            for (int_aux = 0; int_aux <= numero_muescas; int_aux++)
            {
                // pinta la muesca                
                lienzo.DrawLine(pincel, posx - 5, posy, posx + 5, posy);

                // pintamos la linea discontinua horizontal de cada muesca
                for (int_aux2 = 0; int_aux2 < grafica.ancho; int_aux2 = int_aux2 + 10){
                    lienzo.DrawLine(pincel, grafica.origenx + int_aux2, posy, grafica.origenx + int_aux2 + 2, posy);

                }//for

                // printamos el titulo en la muesca
                string_aux = Convert.ToString(altoy * int_aux);
                lienzo.DrawString(string_aux, drawFont_pequena, brocha, posx - (string_aux.Length * 10), posy - 6);

                // incrementamos la variable de posicion Y de la muesca
                posy = posy - (float)(altoy * AY);
            }

            // se pintan los datos

            // para cada equipo contenido en la estructura
            for (int_aux = 0; int_aux < grafica.num_equipos; int_aux++)
            {
                puntos_equipo = 0;
                pincel.Color = grafica.array_equipos[int_aux].color;
                brocha.Color = grafica.array_equipos[int_aux].color;

                // para cada joranda del equipo  
                posx = grafica.origenx;
                posy = grafica.origeny;

                posx_previo = posx;
                posy_previo = posy;

                puntos_equipo = 0;
                int_aux3=0;
                int_aux4=0;                
                for (int_aux2 = (int)grafica.array_equipos[int_aux].inicio_datos_equipo; int_aux2 < grafica.array_equipos[int_aux].final_datos_equipo; int_aux2++)
                {

                    // controlamos el numero de jornadas de la temporada que llevamos para ver si toca "resetear" el contador de puntos
                    if (int_aux4 == grafica.array_jornadas_temporada[int_aux3]){
                        
                        // antes de restear, si hemos llegado al final de la temporada y el equipo es el que tiene mas
                        // puntos en esa temporada de los seleccionados dibujamos una marca
                        if (grafica.array_equipos[int_aux].id_equipo == grafica.array_maximos_puntos_id_equipo[int_aux3]){
                            lienzo.FillEllipse(brocha, (posx - 3), (posy - 3), 6, 6);
                        }//if

                        // reseteamos las variables de control de las temporadas
                        int_aux4 = 1;
                        int_aux3++;// saltamos a la siguiente temporada
                        puntos_equipo = 0;

                        // recalculamos el valor previo, ya que como toca cambio de temporada la linea de la grafica parte del 
                        // eje X , de lo contrario nos vendria una linea desde la ultima jornada de la temporada anterior
                        posx_previo = posx + AX;
                        posy_previo = grafica.origeny;

                    }else{

                        int_aux4++;// se incrementa el contador de jornadas de la temporada

                    }

                    puntos_equipo = puntos_equipo + grafica.array_resultados_trayectorias[int_aux2];

                    posx = posx + AX;
                    posy = grafica.origeny - (float)(puntos_equipo * AY);

                    lienzo.DrawLine(pincel, posx, posy, posx_previo, posy_previo);

                    posx_previo = posx;
                    posy_previo = posy;

                }//for

            }//for

        }//DibujaGraficaTrayectorias



        /*Description:
        *    Inicializa y llena los arrays donde se guarda la informacin de resultados de los partidos jugados por los 
        * equipos seleccionados en el rango de temporadas indicadas en las comboboxes.
        *    seleccionados. Estos arrays se utilizaran luego para construir las grficas de trayectorias.
        * Recives:
        *      division: con la division sobre la queremos realizar los calculos
        *      id_temporda_orig: con el identificador de la temporada a partir de la cual comenzamos a calcular la trayectoria
        *      id_temporda_fin: con el identificador de la temporada hasta la que calculamos la trayectoria
        *   Por valor:
        * Returns:
        */
        private void CalculaValoresGraficasTrayectorias(Analizador.tipo_division division, int id_temporada_orig, int id_temporada_fin)
        {
            ListViewItem lvitem_aux;
            List<int> ListaJornadas = new List<int>();
            int total_jornadas;
            string nombre_equipo;
            int id_equipo;

            uint puntero_equipos; // indice utilizado para recorrer el array de equipos
            uint puntero_resultados_trayectorias; // indice utilizado para recorrer los arrays con los resultados de las taryectorias
            
            int id_eq_local;
            int id_eq_visitante;
            int res_eq_local;
            int res_eq_visitante;

            uint puntos_equipo_temporadas_acumuladas; // se utiliza para sumar los puntos de un equipo a lo largo de todas las temporadas seleccionadas
            uint puntos_equipo_temporada; // se utiliza para sumar los puntos de un equipo en un temporada

            int aux_int;
            int aux_int2;
            int aux_int3;
            int aux_int4;


            string aux_string;


            textBox1.Text = textBox1.Text + "Iniciado calculo de trayectorias\r\n";

            puntero_equipos=0;
            puntero_resultados_trayectorias = 0;

            // inicializamos la informacion de la grafica
            grafica.inicializa();

            // si nos han entrado las temporadas al revs ( es decir primero la de fin y luego la de origen ), l
            // las ordenamos. Podemos hacerlo pq los ids de las temporadas estan ordenados cornologicamente en 
            // la BBDD, siendo los IDs mayores los de temporadas mas antiguas y los IDs menores los de temporadas
            // mas recientes
            if (id_temporada_orig < id_temporada_fin)
            {
                aux_int = id_temporada_orig;
                id_temporada_orig = id_temporada_fin;
                id_temporada_fin = aux_int;
            }//if

            grafica.puntos_temporadas_acumulados_max = 1;
            grafica.puntos_acumulados_max = 1;
            puntos_equipo_temporadas_acumuladas = 0;
            puntos_equipo_temporada = 0;

            // para cada equipo de la listview ( que contiene los equipos seleccionados por el usuario )
            for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
            {
                // obtenemos la informacion del equipo que ocupa la posicion aux_int en la listView1
                lvitem_aux = listView1.Items[aux_int];

                // insertamos la informacin del equipo en el array con la informacion de equipos
                puntero_equipos = (uint) aux_int;
                nombre_equipo = Convert.ToString(lvitem_aux.SubItems[1].Text);
                id_equipo=Analizador.ConsultaIdEquipo(nombre_equipo);
                grafica.array_equipos[puntero_equipos].nombre_equipo = nombre_equipo;
                grafica.array_equipos[puntero_equipos].id_equipo = id_equipo;
                grafica.array_equipos[puntero_equipos].inicio_datos_equipo = puntero_resultados_trayectorias;
                grafica.array_equipos[puntero_equipos].color = lvitem_aux.BackColor;

                textBox1.Text = textBox1.Text + "Calculando "+ nombre_equipo + "\r\n";

                Application.DoEvents();

                // repetimos el siguiente bucle para cada temporda del rango de tempordas seleccionadas ( y tambien 
                // para la division seleccionada ) como queremos que primero hayan los valores de las temporadas mas
                // antiguas y al final los valores de las mas recientes y los IDs de las temporadas estan ordenados
                // al reves, recorreremos los IDs al reves comenzando por el id mayor ( el mas antiguo ) hasta el
                // menor ( el ms reciene ).
                puntos_equipo_temporadas_acumuladas = 0;
                puntos_equipo_temporada = 0;
                for (aux_int2 = id_temporada_orig; aux_int2 >= id_temporada_fin; aux_int2--)
                {
                    total_jornadas = Analizador.ConsultaNumJornadasTemporada(aux_int2, ListaJornadas, division);

                    // guardamos el numero de jornadas que tiene la temporada procesada ( esta un poco mal hecho pq la asignacion se repetira para cada iteracion )
                    grafica.array_jornadas_temporada[id_temporada_orig-aux_int2] = (uint)total_jornadas;

                    // guardamos el nombre de la temporada ( ao1 + ao2 ) para luego poderlo printar en el eje de las X
                    aux_int3 = 0; aux_int4 = 0; aux_string = " ";
                    Analizador.ConsultaTemporada(aux_int2, ref aux_int3, ref aux_int4, ref aux_string);
                    grafica.array_nombres_temporada[id_temporada_orig - aux_int2] = aux_int3.ToString() + " / " + aux_int4.ToString();

                    // repetimos el siguiente bucle para cada jornada de la temporada 
                    puntos_equipo_temporada = 0;
                    for (aux_int3 = 1; aux_int3 <=total_jornadas; aux_int3++)
                    {

                        // consultamos el resultado del equipo en la jornada y temporada procesada
                        id_eq_local = 0; id_eq_visitante = 0; res_eq_local = 0; res_eq_visitante = 0;
                        if (Analizador.ConsultaPartidoEquipoJornada(aux_int2, aux_int3, id_equipo, division, ref id_eq_local, ref id_eq_visitante, ref  res_eq_local, ref  res_eq_visitante) != 0)
                        {

                            if (id_eq_local == id_equipo)
                            {
                                
                                // en esa jornada el equipo solicitado juega como local                                

                                if (res_eq_local > res_eq_visitante)
                                {
                                    // el equipo solicitado gana
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_VICTORIA;
                                }
                                else if (res_eq_local < res_eq_visitante)
                                {
                                    // el equipo solicitado pierde
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_DERROTA;
                                }
                                else
                                {
                                    // el equipo solicitado empata
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_EMPATE;
                                }//if

                            }
                            else
                            {

                                // en esa jornada el equipo solicitado juega como visitante

                                if (res_eq_visitante > res_eq_local)
                                {
                                    // el equipo solicitado gana
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_VICTORIA;
                                }
                                else if (res_eq_visitante < res_eq_local)
                                {
                                    // el equipo solicitado pierde
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_DERROTA;
                                }
                                else
                                {
                                    // el equipo solicitado empata
                                    grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = Analizador.PUNTOS_EMPATE;
                                }//if

                            }//if

                            // sumamos los puntos conseguidos esta jornada al contador de puntos conseguidos a lo largo de todas las jornadas de todas las temporadas
                            puntos_equipo_temporadas_acumuladas = puntos_equipo_temporadas_acumuladas + grafica.array_resultados_trayectorias[puntero_resultados_trayectorias];
                            
                            // sumamos los puntos conseguidos esta jornada al contador de puntos conseguidos a lo largo de esta temporada
                            puntos_equipo_temporada = puntos_equipo_temporada + grafica.array_resultados_trayectorias[puntero_resultados_trayectorias];
                        
                        }
                        else
                        {
                            // si no hay encuentro en esa jornada ponemos un resultado nulo
                            grafica.array_resultados_trayectorias[puntero_resultados_trayectorias] = 0;
                        
                        }//if

                        puntero_resultados_trayectorias++;

                    }//for (aux_int3 = 1; aux_int3 <=total_jornadas; aux_int3++)

                    // miramos si el equipo ha superado el maximo de puntos de todas las temporadas ( se usa para saber como de alto ha de ser el eje Y )
                    if (puntos_equipo_temporada > grafica.puntos_acumulados_max)
                    {
                        grafica.puntos_acumulados_max = puntos_equipo_temporada;
                    }

                    // miramos si el numero de puntos acumulados de esta temporada es mayor que el de los equipos previamente calculados en esta misma temporada
                    if (puntos_equipo_temporada > grafica.array_maximos_puntos_temporada[id_temporada_orig - aux_int2])
                    {
                        grafica.array_maximos_puntos_temporada[id_temporada_orig - aux_int2] = puntos_equipo_temporada;
                        grafica.array_maximos_puntos_id_equipo[id_temporada_orig - aux_int2] = id_equipo; 
                    }//if                        

                }//for (aux_int2 = id_temporada_fin; aux_int2 <= id_temporada_orig; aux_int2++)

                // guardamos la posicion del array de resultados de trayectorias donde hay el ultimo resultado del equipo procesado
                grafica.array_equipos[puntero_equipos].final_datos_equipo = puntero_resultados_trayectorias;

                // si el equipo procesado es el que tiene mas puntos nos guardamos su valor, conocer la puntuacion
                // mxmima nos ser util por ejemplo para dimensionar correctamente los ejes de las grficas
                if (puntos_equipo_temporadas_acumuladas > grafica.puntos_temporadas_acumulados_max)
                {
                    grafica.puntos_temporadas_acumulados_max = puntos_equipo_temporadas_acumuladas;
                }//if

                puntero_equipos++;

            }//for                        
            textBox1.Text = textBox1.Text + "Finalizado el clculo de trayectorias\r\n";

            // calculamos el total de jornadas que luego tendremos que mostrar en el grfico de trayectorias
            grafica.total_jornadas_trayectoria = 0;
            for (aux_int = 0; aux_int<=(id_temporada_orig - id_temporada_fin); aux_int++)
            {
                grafica.total_jornadas_trayectoria = grafica.total_jornadas_trayectoria + grafica.array_jornadas_temporada[aux_int];
            }//for

            // guardamos el numero de temporadas almacenado en el array
            grafica.num_temporadas = (uint)(id_temporada_orig - id_temporada_fin) + 1;
            
            // guardamos el nmero de equipos que hay guardados en el array
            grafica.num_equipos = (uint)listView1.Items.Count;

        }//CalculaValoresGraficasTrayectorias


        private void Form7_Load(object sender, EventArgs e)
        {
            int aux_int;
            int aux_int2;
            int total_temporadas;

            // inicializamos la View List con las etiquetas pertinentes
            listView1.Clear();
            listView1.View = View.Details;// para que se vean los detalles nombre de columna etc

            listView1.Columns.Add("N", 30, HorizontalAlignment.Center);
            listView1.Columns.Add("Equipo", listView1.Width-35, HorizontalAlignment.Center);

            // al cargar el formulario llenamos la combo con los equipos contenidos en la BBDD
            aux_int = Analizador.ConsultaEquipos(ListaEquiposId, ListaEquiposEquipo);

            ListaEquiposEquipo.Sort(); // OJO al ordenar: se nos desparejara la correspondencia entre los arryas de Ids y de Nombres Equipos!!
            for (aux_int2 = 0; aux_int2 < aux_int; aux_int2++)
            {
                comboBox1.Items.Add(ListaEquiposEquipo[aux_int2]);
            }//for

            // se llenan las ComboBoxes con la informacin de las temporadas
            total_temporadas = Analizador.ConsultaTodasTemporadas(Lista_Temporadas_Id, Lista_Temporadas_Anio1_Anio2);
            for (aux_int = 0; aux_int < total_temporadas; aux_int++)
            {
                comboBox2.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
                comboBox3.Items.Add(Lista_Temporadas_Anio1_Anio2[aux_int]);
            }//for

            // inicializamos con la primera y ulima temporada
            comboBox2.Text = Lista_Temporadas_Anio1_Anio2[total_temporadas - 1].ToString();
            comboBox3.Text = Lista_Temporadas_Anio1_Anio2[0].ToString();

            // creamos el bitmap que sera el lienzo donde dibujaremos pintamos ( en l para tener persistencia de la imagen sino al mover los forms, se borran )
             bitmap_con_graficos = new Bitmap(this.ClientRectangle.Width,this.ClientRectangle.Height,System.Drawing.Imaging.PixelFormat.Format24bppRgb);
             
             // pintamos en el lienzo
             DibujaTodo();
             
             // forzamos la llamada al metodo Paint()
             Refresh();

        }

        private void button3_Click(object sender, EventArgs e)
        {
            ListViewItem lvitem_aux;

            // antes de insertar miramos que haya algo seleccionado
            if (comboBox1.SelectedIndex >= 0)
            {
                lvitem_aux = new ListViewItem((listView1.Items.Count + 1).ToString());
                //N
                lvitem_aux.SubItems.Add((comboBox1.Items[comboBox1.SelectedIndex]).ToString());
                lvitem_aux.BackColor = button5.BackColor;
                //Se inserta en la lista
                listView1.Items.Add(lvitem_aux);
            }else{
                MessageBox.Show("ERROR: Debe seleccionar un equipo");
            }//if

        }

        private void button5_Click(object sender, EventArgs e)
        {                              

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {


        }

        private void button1_Click(object sender, EventArgs e)
        {
            // antes de calcular las trayectorias deberemos comprobar que hay elementos en la lista
            if (listView1.Items.Count > 0)
            {

                // en funcion de si esta selecconado el tipo de grafica acumulada dibujamos una grfica u otra
                if (checkBox1.Checked == true)
                {

                    // la opcion de Grafica acumulada esta seleccionada
                    if (radioButton1.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.Primera, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectoriasAcumuladas();
                        DibujaGraficaTrayectoriasAcumuladas();
                    }
                    else if (radioButton2.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.Segunda, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectoriasAcumuladas();
                        DibujaGraficaTrayectoriasAcumuladas();
                    }
                    else if (radioButton3.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.PrimeraSegunda, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectoriasAcumuladas();
                        DibujaGraficaTrayectoriasAcumuladas();
                    }//if

                }
                else
                {

                    // la opcion de grafica acumulada NO esta seleccionada
                    if (radioButton1.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.Primera, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectorias();
                        DibujaGraficaTrayectorias();
                    }
                    else if (radioButton2.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.Segunda, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectorias();
                        DibujaGraficaTrayectorias();
                    }
                    else if (radioButton3.Checked == true)
                    {
                        CalculaValoresGraficasTrayectorias(Analizador.tipo_division.PrimeraSegunda, Lista_Temporadas_Id[comboBox2.SelectedIndex], Lista_Temporadas_Id[comboBox3.SelectedIndex]);
                        DibujaEjesGraficaTrayectorias();
                        DibujaGraficaTrayectorias();
                    }//if

                }//if
            
            }// if (listView1.Items.Count 

            // tras dibujar llamamos al metodo Paint
            Refresh();

        }

        private void textBox2_DoubleClick(object sender, EventArgs e)
        {
     
        }

        private void button5_Click_1(object sender, EventArgs e)
        {
            ColorDialog dialogo_colores = new ColorDialog();

            if (dialogo_colores.ShowDialog() != DialogResult.Cancel)
            {
                button5.BackColor = dialogo_colores.Color;
            }//if
        }



        /*Description:
        *   Funcion que pinta todos los graficos del formulario
        * Recives:
        *   Por referencia:
        * Returns:
        */
        private void DibujaTodo()
        {

            // dependiendo del tipo de grafica seleccionada se pinta un tipo u otro
            if (checkBox1.Checked == true)
            {
                // se limpia el lienzo y se pintan los ejes de la grfica
                DibujaEjesGraficaTrayectoriasAcumuladas();

                // Trayectorias de temporadas acumuladas
                DibujaGraficaTrayectoriasAcumuladas();

            }
            else
            {
                // se pintan los ejes de la grfica
                DibujaEjesGraficaTrayectorias();

                // Trayectoria de cada temporada
                DibujaGraficaTrayectorias();

            }//if

        }

        private void button6_Click(object sender, EventArgs e)
        {
            // han pulsado el boton refrescar asi que limpiamos y repintamos todo
            
            // pintamos en el lienzo
            DibujaTodo();

            // forzamos la llamada al metodo Paint()
            Refresh();
        }

        private void Form7_FormClosing(object sender, FormClosingEventArgs e)
        {
            LFSuite.Form1 FormPadre = (LFSuite.Form1)this.ParentForm;

            // al cerrar y eliminar el formulario ponemos el puntero del padre a null
            FormPadre.form_trayectorias_equipos= null;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            // cerramos el formulario ( se llamara al evento closing que gestiona el tema del puntero en el parent etc.)
            this.Close();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            int aux_int;
            ListViewItem lvitem_aux;

            // si pulsan el Button "Borrar" y hay algun elemento de la ListView seleccionado lo eliminamos
            if (listView1.SelectedItems.Count > 0)
            {
                // se borra el elemento
                listView1.Items.RemoveAt(listView1.SelectedIndices[0]);

                // actualizamos el valor de los indices ( el numero que aparecene en la 1a columna )
                for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
                {
                    lvitem_aux = listView1.Items[aux_int];
                    lvitem_aux.SubItems[0].Text = (aux_int + 1).ToString();

                }//for

            }
            else
            {
                MessageBox.Show("ERROR: No hay equipo seleccionado");

            }//if
        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            int aux_int;
            ListViewItem lvitem_aux;

            // si pulsan el Button "Borrar" y hay algun elemento de la ListView seleccionado lo eliminamos
            if (e.KeyCode == Keys.Delete)
            {

                if (listView1.SelectedItems.Count > 0)
                {
                    // se borra el elemento
                    listView1.Items.RemoveAt(listView1.SelectedIndices[0]);

                    // actualizamos el valor de los indices ( el numero que aparecene en la 1a columna )
                    for (aux_int = 0; aux_int < listView1.Items.Count; aux_int++)
                    {
                        lvitem_aux = listView1.Items[aux_int];
                        lvitem_aux.SubItems[0].Text = (aux_int + 1).ToString();

                    }//for

                }
                else
                {
                    MessageBox.Show("ERROR: No hay equipo seleccionado");
                }//if

            }//if
        }

        private void Form7_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphicsObj = e.Graphics;

            graphicsObj.DrawImage(bitmap_con_graficos, 0, 0, bitmap_con_graficos.Width, bitmap_con_graficos.Height);

            graphicsObj.Dispose();
        }

    }

    class informacion_grafica_trayectorias
    {

        // definimos el array donde se guarda la informacin de los equipos cuyas trayectorias se guardan en el array de 
        // valores de trayectoria, indicando el nombre, el id_equipo, y la posicin en el array de valores de trayectoria 
        // ( array "lineal" ) donde comienzan y acaban los datos de cada equipo. Por tanto los resultados de cada equipo
        // se van guardando en un mismo array lineal,primero todos los resultados del primer equipo, luego todos los 
        // resultados del siguiente, y sucesivamente ... y en la estructua se guarda la posicion inicial y la posicion
        // inicial en que comienza la informacion de cada uno de ellos
        public struct equipos
        {
            public string nombre_equipo;
            public int id_equipo;
            // public uint puntos_iniciales;// puntos que tiene el equipo en el equipo justa antes de la primera temporada del rango
            public uint inicio_datos_equipo;
            public uint final_datos_equipo;
            public Color color;// color que el usuario ha seleccionado para printar la informacion de trayectoria
        };
        public const int MAXIMO_EQUIPOS = 40;
        public uint num_equipos;// con el numero de equipos almacenados en el array
        public equipos[] array_equipos = new equipos[MAXIMO_EQUIPOS];

        // array donde se guardan los resultados de los enfrentamientos de los diferentes equipos a lo largo de las diferentes jornadas
        public const int MAXIMO_ARRAY_TRAYECTORIAS = 32000;
        public uint[] array_resultados_trayectorias = new uint[MAXIMO_ARRAY_TRAYECTORIAS];

        // array donde se guarda el numero de jornadas de cada temporada analizada
        public const int MAXIMO_ARRAY_TEMPORADAS = 150;
        public uint num_temporadas;// con el numero de temporadas almacenadas en el array, es decir con el numero de posiciones usadas
        public uint[] array_jornadas_temporada = new uint[MAXIMO_ARRAY_TEMPORADAS];
        public string[] array_nombres_temporada = new string[MAXIMO_ARRAY_TEMPORADAS];

        // array utilizado para guardar la informacion del equipo que tiene mas puntos cada temporada
        public uint[] array_maximos_puntos_temporada = new uint[MAXIMO_ARRAY_TEMPORADAS]; // array donde guardamos los puntos del equipo con mas puntos al final de cada temporada
        public int[] array_maximos_puntos_id_equipo = new int[MAXIMO_ARRAY_TEMPORADAS];// array donde guardamos el id del equipo con mas puntos en cada temporada


        public uint total_jornadas_trayectoria; // es la suma de todas las jornadas de todas las temporadas analizadas
        public uint puntos_temporadas_acumulados_max; // guarda los puntos de la trayectoria acumulada con mas puntos
        public uint puntos_acumulados_max; // guarda los puntos de la temporada en que se han logrado mas puntos

        // informacion genral de posicion del grafico
        public uint origenx = 65;
        public uint origeny = 335;
        public uint alto = 295;
        public uint ancho = 970;

        public informacion_grafica_trayectorias()
        {
            uint ui_aux;

            // vaciamos el array con resultados de trayectorias
            for (ui_aux=0;ui_aux<MAXIMO_ARRAY_TRAYECTORIAS;ui_aux++)
            {
                array_resultados_trayectorias[ui_aux] = 0;
            }

            // incializamos la informacion de los equipos
            for (ui_aux=0;ui_aux<MAXIMO_EQUIPOS;ui_aux++)
            {
                array_equipos[ui_aux].inicio_datos_equipo = 0;
                array_equipos[ui_aux].final_datos_equipo = 0;
                array_equipos[ui_aux].id_equipo = 0;
                array_equipos[ui_aux].nombre_equipo = "";                
            }

            // incializamos la informacion de las temporadas
            for (ui_aux=0;ui_aux<MAXIMO_ARRAY_TEMPORADAS;ui_aux++)
            {                
                array_jornadas_temporada[ui_aux] = 0;
                array_nombres_temporada[ui_aux] = "";
                array_maximos_puntos_temporada[ui_aux] = 0;
                array_maximos_puntos_id_equipo[ui_aux] = 0;
            }

        }

        ~informacion_grafica_trayectorias()
        {
        }


        /*Description:
        *  Funcion que inicializa las estructuras donde se guarda la informacion utilizada en las graficas
        * Recives:
        * Returns:
        * Por valor:
        */
        public void inicializa()
        {
            uint ui_aux;

            // vaciamos el array con resultados de trayectorias
            for (ui_aux = 0; ui_aux < MAXIMO_ARRAY_TRAYECTORIAS; ui_aux++)
            {
                array_resultados_trayectorias[ui_aux] = 0;
            }

            // incializamos la informacion de los equipos
            for (ui_aux = 0; ui_aux < MAXIMO_EQUIPOS; ui_aux++)
            {
                array_equipos[ui_aux].inicio_datos_equipo = 0;
                array_equipos[ui_aux].final_datos_equipo = 0;
                array_equipos[ui_aux].id_equipo = 0;
                array_equipos[ui_aux].nombre_equipo = "";
            }

            // incializamos la informacion de las temporadas
            for (ui_aux = 0; ui_aux < MAXIMO_ARRAY_TEMPORADAS; ui_aux++)
            {
                array_jornadas_temporada[ui_aux] = 0;
                array_nombres_temporada[ui_aux] = "";
                array_maximos_puntos_temporada[ui_aux] = 0;
                array_maximos_puntos_id_equipo[ui_aux] = 0;
            }
        }

    }//informacion_grafica_trayectorias

}

